/*
 * FILE     : assoc_pstree.cpp
 * Copyright (C) 
 * SYSTEM   : 
 * FUNCTION : 敪؂̕t\̒`
 * AUTHER   : 
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "assoc_pstree.h"

/*  ID_PSTrees::new_pst	VKPst[]ɒǉ
***************************************************************************/
int PSTrees::new_pst()
{
	int d;
	if( topEmpty <= 0 ) {
		d = ary.size();
		ary.push_back(PSTreeAsoc()); CHKB(-1, ary[d].emptyNext, -1);
	} else {
		d = topEmpty;
		topEmpty = ary[d].emptyNext;
		ary[d].emptyNext = -1;   //gp NT110803add
		ary[d].clear();
//I		ary[d] = X;
	}                                   CHKB(0, ary[d].n_pair, 0);
	++n_ary;
	return d;
}
/*  ID_PSTrees::del_pst	󃊃Nɂ
***************************************************************************/
int PSTrees::del_pst( int *d )
{	                   //CHKA(1, d, ary.size()); Ɏc
	if( *d > 0 ) {
		ary[*d].clear();
		ary[*d].emptyNext = topEmpty;
		topEmpty = *d;
		--n_ary;
	}
	*d = 0;
	return 0;
}
/*  ID_PSTrees::clear	NABSĂNɓ
***************************************************************************/
int PSTrees::clear()
{
	int d, e ;
	for( d = 1; d < ary.size(); ++d ) {
		e = d;
		if( ary[d].emptyNext < 0 ) del_pst(&e);
	}                                   CHKB(0, n_ary, 0);
	for( d = 2; d < ary.size(); ++d ) {
		ary[d-1].emptyNext = d;
	}
	n_ary = 0;
	if( ary.size() <= 1 ) { //ary[0]͎gȂ̂ŊɓȂ
		topEmpty = 0;
	} else {
		topEmpty = 1;
		ary[d-1].emptyNext = 0;
	}
	return 0;
}
/*  ID_PSTrees::plus	``{a
***************************************************************************/
int PSTrees::plus(int *a, int b)
{
	int rc = 0;
	if( b > 0 ) {
		if( *a <= 0 ) *a = new_pst();
		rc = ary[*a].plus(ary[b], vecIntWk1, vecIntWk2, vecIntWk3);
	}
	return rc;
}
/*  ID_PSTrees::minus	``|a
***************************************************************************/
int PSTrees::minus(int *a, int b)
{
	int rc = 0;
	if( *a > 0 ) {
		if( b > 0 )
			rc = ary[*a].minus(ary[b], vecIntWk1, vecIntWk2, vecIntWk3);
		if( ary[*a].root == 0 )
			del_pst(a);
	}
	return rc;
}
/*  ID_PSTrees::intersect	x`a
***************************************************************************/
int PSTrees::intersect(int *y, int a, int b)
{
	int rc = 0;
	if( a > 0 && b > 0 ) {
		if( *y <= 0 )
			*y = new_pst();
		rc = ary[*y].intersect(ary[a], ary[b], vecIntWk1, vecIntWk2, vecIntWk3);
		if( ary[*y].root == 0 )
			del_pst(y);
	} else if( *y > 0 ) {
		del_pst(y);
	}
	return rc;
}
