/*
 * FILE     : drtree_check.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "drtree.h"

/*  ID_DrTrees::check_ans	query̓̃`FbN
***************************************************************************/
int DrTrees::check_ans(
	int *low,
	int *high)
{
	int i, apoin, *vvect;
	DRTPoint *vpoint;
//	VECTOR<int> &sortwk = *vectPool.newVect();
//	                                    CHKB(0, sortwk.size(), 0);
	pListC.clear();
	for( apoin = 0; apoin < points.a.size(); ++apoin )
		pListC.push_back(0);
	for( i = 0; i < ans.size(); ++i ) {
		apoin = ans[i];                 CHKA(0, apoin, points.a.size());
		if( apoin < 0 || apoin >= points.a.size() ) continue;
		                                CHKB(0, pListC[apoin], 0);
		pListC[apoin] = 1;              CHKB(1, points.a[apoin].usef, 1);
	}
	for( apoin = 0; apoin < points.a.size(); ++apoin ) {
		vpoint = &points.a[apoin];
		vvect  = &points.x[vpoint->topX];
		if( vpoint->usef == 0 ) {
			CHKB(0, pListC[apoin], 0);
		} else if( compVectLE(0, low , vvect) && compVectLE(0, vvect, high) ) {
			CHKB(1, pListC[apoin], 1);
		} else {
			CHKB(0, pListC[apoin], 0);
		}
	}
//	vectPool.delVect(&sortwk);
	return 0;
}
/*  ID_DrTrees::drtree_check1	̈؂̃`FbNPioXȊOj
***************************************************************************/
int DrTrees::drtree_check1(
	int level,          //i ̈؂̃x
	int anod,           //i Ώۃm[h     (>0)
	int oyaNode,        //i anod ̐em[h(=0 )
	int *low,           //i Œl
	int *high)          //i ōl
{
	int		pntko, lowi, highi, *vvect;
	DRTNode	*wnod, *wnod2;
	DRTPoint	*wpnt;
							            CHKA(0, anod, nodes.a.size());
										CHKA(0, oyaNode, nodes.a.size());
	if( anod <= 0 ) goto                                              quit;
	wnod = &nodes.get(anod);
	pntko = wnod->point;	            CHKA(0, pntko, points.a.size());     //|Cgԍ̃`FbN
	wpnt = &points.a[pntko];            CHKB(1, wpnt->usef, 1);              //gp̂͂
	                        CHKA(0, wnod->left, nodes.a.size()); //v CHKB(level, wnod->level, level);
	                        CHKA(0, wnod->right, nodes.a.size());
	//ŉʃx̒T؂ɂ͓؂ȂB
	if( level + 1 >= dim - 1 )  { CHKB(0, wnod->assocAVL, 0); CHKB(0, wnod->asocT, 0);
	//tɂ͓؂ȂB
	} else if( wnod->left == 0 && wnod->right == 0 ) {
		                    CHKB(0, wnod->assocAVL, 0); CHKB(0, wnod->asocT, 0);
	//ɂ͓؂ȂB
	} else if( nodes.a[oyaNode].left != anod && nodes.a[oyaNode].right != anod ) {
		                    CHKB(0, wnod->assocAVL, 0); CHKB(0, wnod->asocT, 0);
	//ŉ̂QiPSTreeœ؂B
	} else if( level + 2 >= dim - 1)  {    CHKB(1, 1, wnod->asocT);
	//LȊOAVLTreeœ؂B
	} else {                            CHKA(1, wnod->assocAVL, nodes.a.size());
	}
	//m[h̒l͈̔̓`FbN
	vvect  = &points.x[wpnt->topX];     CHKB(low[level], vvect[level], high[level]);
	//̐em[h anod ̐em[h͓͂im[hj
	if( oyaNode > 0 ) {
		wnod2 = &nodes.get(oyaNode);
		//anod ́Aem[h́Aleft, right, assocAVL ̂ǂꂩƈv͂
		if( wnod2->right != anod && wnod2->left != anod ) {
			if( wnod2->asocT == 0 ) CHKB(anod, wnod2->assocAVL, anod)
			else                    CHKB(anod, wnod2->asocT, anod)
		}
	}
	vvect  = &points.x[wpnt->topX];     CHKB(low[level], vvect[level], high[level]);
	//oya, left, right, assocAVL ̒lm[hl͈͓̔ۂ`FbN
	//؂̒l`FbN
	if( wnod->assocAVL != 0 ) drtree_check1(level+1, wnod->assocAVL, anod, low, high);
//	if( wnod->asocT    != 0 ) drtree_check1(level+1, wnod->assocAVL, anod, low, high);
	//q؂̒l`FbN
	highi = high[level]; high[level] = vvect[level];
	if( wnod->left  != 0 ) drtree_check1(level  , wnod->left,  anod, low, high);
	//Eq؂̒l`FbN
	lowi = low[level];  low[level] = vvect[level]; high[level] = highi;
	if( wnod->right != 0 ) drtree_check1(level  , wnod->right, anod, low, high);
	low[level] = lowi; 
quit:
	return 0;
}
/*  ID_DrTrees::check_balance	̈؂̃`FbNQioX̂݁j
***************************************************************************/
int DrTrees::check_balance(  //m[h̍Ԃ
	int anod)
{
	DRTNode *wnod;
	int h, hL, hR;

	if( anod <= 0 ) {
		h = 0;
	} else {
		wnod = &nodes.get(anod);
		hL = check_balance( wnod->left );
		hR = check_balance( wnod->right);
		CHKB(hL - 1, hR, hL + 1);
		CHKB(wnod->type, hR - hL, wnod->type);
		h  = check_balance( wnod->assocAVL);
		h = 1 + ((hL > hR) ? hL : hR);
	}
	return h;
}
