/*
 * FILE     : drtree_del.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.06.08
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include "drtree.h"

/*  ID_DrTrees::del_assocAVL	m[hassocȉ̗̈؂폜
***************************************************************************/
int DrTrees::del_assocAVL(  //r ɂOԂ
	int level,           //i assoc̃x
	int assoc)           //i ؂̍     nodes.a[]
{
	if( assoc > 0 ) {
		del_assocAVL(level, nodes.a[assoc].right);
		del_assocAVL(level, nodes.a[assoc].left);
		del_assoc(level, assoc); //؂폜
		nodes.del(assoc);
	}
	return 0;
}
/*  ID_DrTrees::del_assoc	m[hnp̓؂폜
***************************************************************************/
int DrTrees::del_assoc(  //r ɂOԂ
	int level,           //i np̃x
	int np)              //i                            nodes.a[]
{
	                                    CHKA(1, np, nodes.a.size());
	if( level + 2 < dim - 1 ) {
		nodes.a[np].assocAVL = del_assocAVL(level+1, nodes.a[np].assocAVL);
	} else if( level + 1 < dim - 1 ) {
		psts.del_pst(&nodes.a[np].asocT);
	} else                      CHKA(level, dim, -571);
	return 0;
}
/*  ID_DrTrees::del_assoc_point	m[hnr̓؂폜Ώۂ̃|Cgpp폜
***************************************************************************/
int DrTrees::del_assoc_point(  //r ɂOԂ
	int level,           //i nr̃x
	int nr,              //i                            nodes.a[]
	int pp)              //i point[]
{
	int pn, px, py, wkdelfg, wkfndfg;   CHKA(1, nr, nodes.a.size()); CHKA(0, pp, points.a.size());
	if( level + 2 < dim - 1 ) {
		nodes.a[nr].assocAVL = Bitr_del(level+1, pp, nodes.a[nr].assocAVL, &wkdelfg, &wkfndfg );
	} else if( level + 1 < dim - 1 ) {
		points.getLast2(pp, &pn, &px, &py);
		psts.ary[nodes.a[nr].asocT].deletion(pn, px, py);
	} else                      CHKA(level, dim, -571);
	return 0;
}
/*  ID_DrTrees::rotate_single_assoc	P]ł̓؂̏C
***************************************************************************/
int DrTrees::rotate_single_assoc(  //r 
	int level,           //i ̈؂̃x
	int np,              //i oXÕTu؂̍m[hԍ  node[]
	int p1)
{
	int assoc;
	del_assoc(level, p1);
	if( level + 2 < dim - 1 ) {
		nodes.a[p1].assocAVL = nodes.a[np].assocAVL;
		assoc = mearge( level + 1, np);
		nodes.a[np].assocAVL = assoc;
	} else if( level + 1 < dim - 1 ) {
		nodes.a[p1].asocT = nodes.a[np].asocT;
		assoc = meargePst( level + 1, np);
		nodes.a[np].asocT = assoc;
	} else { CHKB(0, nodes.a[np].assocAVL, 0); CHKB(0, nodes.a[p1].assocAVL, 0);
			 CHKB(0, nodes.a[np].asocT, 0); CHKB(0, nodes.a[p1].asocT, 0); }
	return 0;
}
/*  ID_DrTrees::rotate_double_assoc	Qd]ł̓؂̏C
***************************************************************************/
int DrTrees::rotate_double_assoc(  //r 
	int level,           //i ̈؂̃x
	int np,              //i oXÕTu؂̍m[hԍ  node[]
	int p1,
	int p2)
{
	int assoc;
	del_assoc(level, p1);
	del_assoc(level, p2);
	if( level + 2 < dim - 1 ) {
		nodes.a[p2].assocAVL = nodes.a[np].assocAVL;
		assoc = mearge( level + 1, np);
		nodes.a[np].assocAVL = assoc;
		assoc = mearge( level + 1, p1);
		nodes.a[p1].assocAVL = assoc;
	} else if( level + 1 < dim - 1) {
		nodes.a[p2].asocT = nodes.a[np].asocT;
		assoc = meargePst( level + 1, np);
		nodes.a[np].asocT = assoc;
		assoc = meargePst( level + 1, p1);
		nodes.a[p1].asocT = assoc;
	} else { CHKB(0, nodes.a[np].assocAVL, 0); CHKB(0, nodes.a[p1].assocAVL, 0); CHKB(0, nodes.a[p2].assocAVL, 0);
			 CHKB(0, nodes.a[np].asocT, 0); CHKB(0, nodes.a[p1].asocT, 0); CHKB(0, nodes.a[p2].asocT, 0); }
	return 0;
}
/*  ID_DrTrees::Bitr_balL	m[h̃oXiE̎}dȂ or ̎}yȂj
***************************************************************************/
int DrTrees::Bitr_balL(  //r oX̃Tu؂̍m[hԍ  node[]
	int level,           //i ̈؂̃x
	int np,              //i oXÕTu؂̍m[hԍ  node[]
	int *addfg,
	int *delfg)          //io 폜ɖ؂̍ 1:k 0:sρBP̂͂
{
	int p1, p2;
	int 	t1;
	                                    CHKB(1, *delfg, 1);
	if( nodes.a[np].type == L ) {
		nodes.a[np].type = E;
		if( nodes.a[np].left <= 0 ) {   CHKB(0, nodes.a[np].right, 0);
			//tm[hɂȂ瓯؂폜
			del_assoc(level, np);
		}
		*addfg   = 0;
	} else if( nodes.a[np].type == E ) {
		nodes.a[np].type = R;
		*delfg   = 0;
	} else {               /* ăoX */
		p1 = nodes.a[np].right;
		t1 = nodes.a[p1].type;
		if( t1 == E || t1 == R ) { /* Pqq] */
			nodes.a[np].right = nodes.a[p1].left;
			nodes.a[p1].left  = np;
			if( t1 == E ) {
				nodes.a[np].type = R;
				nodes.a[p1].type = L;
				*delfg   = 0;
			} else {
				nodes.a[np].type = E;
				nodes.a[p1].type = E;
			}
			//	P]ł̓؂̏C
			rotate_single_assoc(level, np, p1);
			np = p1;
			*addfg   = 0;
		} else {                  /* Qdqk] */
			p2 = nodes.a[p1].left;
			nodes.a[p1].left  = nodes.a[p2].right;
			nodes.a[p2].right = p1;
			nodes.a[np].right = nodes.a[p2].left;
			nodes.a[p2].left  = np;
			if( nodes.a[p2].type == R ) nodes.a[np].type = L;
			else                        nodes.a[np].type = E;
			if( nodes.a[p2].type == L ) nodes.a[p1].type = R;
			else                        nodes.a[p1].type = E;
			//Qd]ł̓؂̏C
			rotate_double_assoc(level, np, p1, p2);
			np = p2;
			nodes.a[p2].type = E;
			*addfg   = 0;
		}
	}
	return( np );
}
/*  ID_DrTrees::Bitr_balR	Em[h̃oXi̎}dȂ or E̎}yȂj
***************************************************************************/
int DrTrees::Bitr_balR(  //r oX̃Tu؂̍m[hԍ  node[]
	int level,           //i ̈؂̃x
	int np,              //i oXÕTu؂̍m[hԍ  node[]
	int *addfg,
	int *delfg)          //io 폜ɖ؂̍ 1:k 0:sρBP̂͂
{
	int p1, p2;  //node[]
	int 	t1;
	                                    CHKB(1, *delfg, 1);
	if( nodes.a[np].type == R )	{
		nodes.a[np].type = E;
		if( nodes.a[np].left <= 0 ) {   CHKB(0, nodes.a[np].right, 0);
			//tm[hɂȂ瓯؂폜
			del_assoc(level, np);
		}
		*addfg   = 0;
	} else if( nodes.a[np].type == E ) {
		nodes.a[np].type = L;
		*delfg   = 0;
	} else {               /* ăoX */
		p1 = nodes.a[np].left;
		t1 = nodes.a[p1].type;
		if( t1 == E || t1 == L) { /* Pkk] */
			nodes.a[np].left  = nodes.a[p1].right;
			nodes.a[p1].right = np;
			if( t1 == E ) {
				nodes.a[np].type = L;
				nodes.a[p1].type = R;
				*delfg   = 0;
			} else {
				nodes.a[np].type = E;  //<==
				nodes.a[p1].type = E;
			}
			//	P]ł̓؂̏C
			rotate_single_assoc(level, np, p1);
			np = p1;
			*addfg   = 0;
		} else {                 /* Qdkq] */
			p2 = nodes.a[p1].right;
			nodes.a[p1].right = nodes.a[p2].left;
			nodes.a[p2].left  = p1;
			nodes.a[np].left  = nodes.a[p2].right;
			nodes.a[p2].right = np;
			if( nodes.a[p2].type == L ) nodes.a[np].type = R;
			else                        nodes.a[np].type = E; //<==
			if( nodes.a[p2].type == R ) nodes.a[p1].type = L;
			else                        nodes.a[p1].type = E; //<==
			//Qd]ł̓؂̏C
			rotate_double_assoc(level, np, p1, p2);
			np = p2;
			nodes.a[p2].type = E;
			*addfg   = 0;
		}
	}
	return( np );
}
/*  ID_DrTrees::Bitr_unlnk	폜Ώۃ|Cg̃m[hɍEqLB̎q̉E[̎qA폜m[hɃRs[B
***************************************************************************/
int DrTrees::Bitr_unlnk( //r 
	int level,           //i ̈؂̃x
	int q,               //i node[]
	int r,               //io node[]
	int *addfg,
	int *delfg)          //o 폜ɖ؂̍ 1:k 0:s
{
	int rc;
						//CHKB(NO,*delfg,YES);
	if( nodes.a[r].right != NULL ) { //E}炽ǂ
		nodes.a[r].right = Bitr_unlnk(level, q, nodes.a[r].right, addfg, delfg );
		//؂폜Ώۂ̃|Cg폜
		del_assoc_point(level, r, nodes.a[q].point);
		if( *delfg ) rc = Bitr_balR(level, r, addfg, delfg );
		else         rc = r;
	} else { //E}炻̃m[h̃|Cgm[hɃRs[āÃm[h폜
		nodes.a[q].point = nodes.a[r].point;
		del_assoc(level, r);
		rc = nodes.a[r].left;
		nodes.del(r);
		*delfg = 1;
	}
	return( rc );
}
/*  ID_DrTrees::Bitr_del	̈؂|Cg폜
***************************************************************************/
int DrTrees::Bitr_del(  //r 폜̃Tu؂̍m[hԍ
	int level,          //i ̈؂̃x
	int apoin,          //i 폜|Cgԍ                point[]
	int aroot,          //i 폜Ώۂ̃Tu؂̍m[hԍ    node[]
	int *delfg,         //o 폜ɖ؂̍ 1:k 0:s
	int *fndfg )        //o 폜m[h 1: 0:
{
	int 	rc, np, q, wkaddfg, newroot;
							//CHKB(0, *delfg, 0);
	newroot = aroot;
	if( aroot <= 0 ) {   /* 폜Ώۃm[h𔭌ł */
		*delfg = 0;                 //  CHKA(-1, apoin, -1); /* łȂ̂bgj */
		*fndfg = 0;
	} else if( (rc = compPointL(level, apoin, nodes.a[aroot].point)) < 0 ) {
		//؂폜Ώۂ̃|Cg폜
		del_assoc_point(level, aroot, apoin);
		//
		np = Bitr_del(level,  apoin, nodes.a[aroot].left, delfg, fndfg );
		nodes.a[aroot].left = np;
		//ĂoX蒼B
		if( *delfg ) newroot = Bitr_balL(level, aroot, &wkaddfg, delfg );
	} else if( rc > 0 ) {
		//؂폜Ώۂ̃|Cg폜
		del_assoc_point(level, aroot, apoin);
		//
		np = Bitr_del(level,  apoin, nodes.a[aroot].right, delfg, fndfg );
		nodes.a[aroot].right = np;
		//ĂoX蒼B
		if( *delfg ) newroot = Bitr_balR(level, aroot, &wkaddfg, delfg );
	} else {             /* 폜Ώۃm[h𔭌 */
		q = aroot;
		if( nodes.a[q].right == NULL ) {       /* E̎qB */
			newroot = nodes.a[q].left;
			*delfg = 1;
			del_assoc(level, q);
			nodes.del( q );
		} else if( nodes.a[q].left == NULL ) { /* E̎qLA̎qB */
			newroot = nodes.a[q].right;
			*delfg  = 1;
			del_assoc(level, q);
			nodes.del( q );
		} else { /* qLB̎q̉E[̎qA폜m[hɃRs[B */
			nodes.a[q].left = Bitr_unlnk(level, q, nodes.a[q].left, &wkaddfg, delfg );
			//؂폜Ώۂ̃|Cg폜
			del_assoc_point(level, aroot, apoin);
			if( *delfg ) newroot = Bitr_balL(level, aroot, &wkaddfg, delfg );
		}
/*		free( q ); /* */
		*fndfg = 1;
	}
	return( newroot );
}	
/*  ID_DrTrees::delpoint	̈؂瓮IɂP̓_폜
***************************************************************************/
int DrTrees::delpoint(	//rc=0:, -1:m[hԍȂ
	int poNo)            //i 폜|Cg̔ԍ
{
	int rc = 0, delfg, fndfg;        CHKA(0, poNo, points.a.size());
	if( poNo < 0 || poNo >= points.a.size() ) { rc = -1; goto quit; }
	                                    CHKB(1, points.a[poNo].usef, 1);
	mainTree = Bitr_del(0, poNo, mainTree, &delfg, &fndfg ); CHKB(1, fndfg, 1);
	if( fndfg ) {
		points.del(poNo);
	} else {
		rc = -1;
	}
quit:
	return rc;
}
