/*
 * FILE     : drtree_ins.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include "drtree.h"

/*  ID_DrTrees::add_assoc_point	m[hpnode̓؂֑Ώۂ̃|Cgpntidxǉ
***************************************************************************/
int DrTrees::add_assoc_point(  //r ɂOԂ
	int level,           //i oyaNodẽx
	int oyaNode,         //i pnode ̐em[h
	int pnode,           //i                            nodes.a[]
	int pntidx)          //i point[]
{
	int pn, px, py, wkaddfg, assoc;   CHKA(1, pnode, nodes.a.size()); CHKA(0, pntidx, points.a.size());
	if( level + 2 < dim - 1 ) {
		if( nodes.a[pnode].assocAVL > 0 ) {
			assoc = Bitr_add(level+1, nodes.a[pnode].assocAVL, pnode, pntidx, &wkaddfg);
			nodes.a[pnode].assocAVL = assoc;
		} else if( oyaNode > 0 && (nodes.a[oyaNode].left == pnode || nodes.a[oyaNode].right == pnode) ) {
			assoc = mearge(level+1, pnode);
			nodes.a[pnode].assocAVL = assoc;
		}
	} else if( level + 1 < dim - 1 ) {
		if( nodes.a[pnode].asocT > 0 ) {
			points.getLast2(pntidx, &pn, &px, &py);
			psts.ary[nodes.a[pnode].asocT].insert( pn,  px,  py);
		} else if( oyaNode > 0 && (nodes.a[oyaNode].left == pnode || nodes.a[oyaNode].right == pnode) ) {
			assoc = meargePst(level+1, pnode);
			nodes.a[pnode].asocT = assoc;
		}
	} else                      CHKA(level, dim, -571);
	return 0;
}
/*  ID_DrTrees::Bitr_add	level̈؂Ƀ|Cgǉ
***************************************************************************/
int DrTrees::Bitr_add(  //r: c[̃[gm[hԍ(mainTree)
	int level,          //i  ̈؂̃xB0..dim-1
	int pnode,          //i  ǉTu؂̍m[h
	int oyaNode,        //i  pnode ̐em[h
	int pntidx,         //i  |Cgԍ                point[]
	int *addfg)         //io ǉtO =1:ǉ, =0:ǉȂ
{
	int		rc = 0, anode, wkaddfg;
						CHKB(0, pnode, nodes.a.size()); CHKA(0, pntidx, points.a.size()); CHKA(0, level, this->dim);
						CHKB(0, oyaNode, nodes.a.size());
	rc = pnode;
	/* VKm[h쐬 */
	if( pnode == 0 ) {   /* VKm[h쐬 */
		anode = nodes.ins(oyaNode, 0, 0, pntidx, 0, level);
		nodes.setval(anode, oyaNode, 0, 0, pntidx, 1);
		rc = anode;
		*addfg = 1;
	} else if( compPointL(level, nodes.a[pnode].point, pntidx) > 0 ) {
		/* Tu؂ɒǉ */
		anode = Bitr_add(level, nodes.a[pnode].left, pnode, pntidx, addfg);
		nodes.a[pnode].left = anode;
		//؂֑Ώۂ̃|Cgǉ
		add_assoc_point( level, oyaNode, pnode, pntidx);
		if( *addfg == 0 ) goto                   quit;
		/* ̎}dȂ */
		wkaddfg = 1;
		rc = Bitr_balR(level, pnode, addfg, &wkaddfg);
	} else {                                  /*  */
		/* ETu؂ɒǉ */
		anode = Bitr_add(level, nodes.a[pnode].right, pnode, pntidx, addfg);
		nodes.a[pnode].right = anode;
		//؂֑Ώۂ̃|Cgǉ
		add_assoc_point( level, oyaNode, pnode, pntidx);
		if( *addfg == 0 ) goto                   quit;
		/* E̎}dȂ */
		wkaddfg = 1;
		rc = Bitr_balL(level, pnode, addfg, &wkaddfg);
	}
quit:
	return(rc);
}
/*  ID_DrTrees::addpoint	̈؂ɓIɂP̓_ǉ
***************************************************************************/
int DrTrees::addpoint( //r -1:m[hԍ -2:dimقȂ
	int pdim,          //
	int poNo,     //|Cgԍ
	int *pnt )
{
	int 	rc = 0, apoint, level = 0, anod = 1, oyanod = 0, addfg = 0;

	if( this->dim == 0 ) { this->dim = pdim;
	} else if( this->dim != pdim ) { rc = -2; goto                     quit;
	}
	apoint = points.ins(pdim, poNo, pnt);    //|CgWɒǉ
	if( apoint < 0 ) { rc = -1; goto                    quit; }
	mainTree = Bitr_add(level, mainTree, oyanod, apoint, &addfg);
	rc = 0;
quit:
	return(rc);
}
