/*
 * FILE     : recttreemain.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : I`T؁BI敪؁{PSTreeƗ̈ؓI敪؁{PSTreeB`dȂT
 * AUTHER   : N.Tsuchiya  2011.05.06
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#define EXTERN
#include "recttree.h"
#include "recttree_memo.h"
#include "xset.h"
//#include "rectIntsect.h"

#if ! defined(_DEBUG)
#  define TAIRYO
#endif

int poi[100000][4];  //eXgp|Cg
//VECTOR<int> sortnd;
int xi[][4] = { //x1, x2, y1, y2
	{ 12, 21, 24, 33},
	{ 15, 26,  7, 18},
	{  9, 22, 11, 13},
	{ 10, 23, 14, 42},
	{  8, 35, 17, 30},
	{ 31, 39, 16, 19},
	{ 12, 19, 15, 25},
	{ 24, 41, 26, 29},
	{ 16, 29,  6, 31},
};
//static void dump_nod(SegTree &sst)
//{
//	int i, k, inf;
//
//	Dprintf("sst.nodes.a.size()(%d)\n", sst.nodes.a.size());
//	for( i = 1; i < sst.nodes.a.size(); ++i ) {
//		SegNode &nd = sst.nodes.a[i];
//		Dprintf("%2d)key(%10f)left(%2d)right(%2d)type(%2d) segt_pst"
//		, i, nd.key, nd.left, nd.right, nd.type);
//		for( k = nd.asocT->firstPair(&inf); k >= 0; k = nd.asocT->nextPair(&inf) ) {
//			Dprintf("(%2d)", k);
//		}
//		Dprintf("\n");
//	}
//	return;
//}
/*  ID_check_point_set_sub	|CgW̍쐬
***************************************************************************/
static int check_point_set_sub(
	RectTree &rectr,
	int anod, int *cnt, Xset_s *idxset)
{
	int rc = 0, apoint;

	if( anod > 0 ) {
		apoint = rectr.drt.nodes.a[anod].point;
		if( idxset->exist(apoint) )      CHKA(0, apoint, -1);  //|Cgԍ͌Ȃ͂
		++*cnt;
		if( (rc = idxset->push(apoint)) < 0 ) goto                                      quit;
		if( (rc = check_point_set_sub(rectr, rectr.drt.nodes.a[anod].left, cnt , idxset)) < 0 ) goto quit;
		if( (rc = check_point_set_sub(rectr, rectr.drt.nodes.a[anod].right, cnt, idxset)) < 0 ) goto quit;
	}
quit:
	return rc;
}
/*  ID_check_point_set	؂Ƃ̃|CgW̃`FbN
***************************************************************************/
int check_point_set(
	RectTree &rectr,
	Xset_s *idxset1, Xset_s *idxset2)
{
	int rc = 1, rc1, i, j, cnt1, cnt2;
	DRTNode *nod;
	for( i = 1; i < rectr.drt.nodes.a.size(); ++i ) {
		nod = &rectr.drt.nodes.a[i];
//e		if( drt.nodes.a[i].emptyNext >= 0 ) continue;  //
		if( rectr.drt.nodes.a[i].left < 0 ) continue;  //-1:m[h
		if( nod->left <= 0 && nod->right <= 0 ) {        CHKB(0, nod->assocAVL, 0); //tɂ͓؂͍Ȃ
		}
		if( nod->assocAVL > 0 ) {
			//
			idxset1->clear();
			idxset2->clear();
			cnt1 = cnt2 = 0;
			check_point_set_sub(rectr, nod->assocAVL, &cnt2, idxset2);    //؂̃m[h
			check_point_set_sub(rectr, i, &cnt1, idxset1);                       //m[hȉ̃Tu؂̃m[h
											CHKB(cnt1, cnt2, cnt1);    //Hm[h͓͂ ???
			for( j = idxset1->first(); j > 0; j = idxset1->next(j) ) {
				rc1 = idxset2->exist(j);     CHKB(1, rc1, 1);
				if( rc1  != 1 ) rc = 0;
			}
			for( j = idxset2->first(); j > 0; j = idxset2->next(j) ) {
				rc1 = idxset1->exist(j);     CHKB(1, rc1, 1);
				if( rc1  != 1 ) rc = 0;
			}
		} else if( nod->asocT > 0 ) {
		}
	}
	return rc;
}
/*  ID_check_empty_set_sub	|Cgƃm[h̏W̍쐬
***************************************************************************/
static int check_empty_set_sub(
	RectTree &rectr,
	int anod,
	Xset_s *idxset1,      //nodep
	Xset_s *idxset2)      //pointp
{
	int rc = 0, apoint;

	if( anod > 0 ) {                      CHKA(0, rectr.drt.nodes.a[anod].left, rectr.drt.nodes.a.size());  //-1:gp
		apoint = rectr.drt.nodes.a[anod].point; CHKB(1, rectr.drt.points.a[apoint].usef, 1);  //-1:gp
		if( idxset1->exist(anod) )        CHKA(0, anod, -1);  //m[hԍ͌Ȃ͂
		if( (rc = idxset1->push(anod)) < 0 ) goto                                 quit;
		if( (rc = idxset2->push(apoint)) < 0 ) goto                                 quit;
		if( (rc = check_empty_set_sub(rectr, rectr.drt.nodes.a[anod].left , idxset1, idxset2)) < 0 ) goto quit;
		if( (rc = check_empty_set_sub(rectr, rectr.drt.nodes.a[anod].right, idxset1, idxset2)) < 0 ) goto quit;
		//؂Ώ
		if( (rc = check_empty_set_sub(rectr, rectr.drt.nodes.a[anod].assocAVL, idxset1, idxset2)) < 0 ) goto quit;
	}
quit:
	return rc;
}
/*  ID_check_empty_set	|Cgƃm[h̋Ǘ̃`FbN
***************************************************************************/
int check_empty_set(
	RectTree &rectr,
	Xset_s *idxset1, Xset_s *idxset2)
{
	int rc = 1, i;

	idxset1->clear();
	idxset2->clear();
	rc = check_empty_set_sub(rectr, rectr.drt.mainTree, idxset1, idxset2);
	for( i = 0; i < rectr.drt.points.a.size(); ++i ) {
		if( idxset2->exist(i) ) { CHKB(1, rectr.drt.points.a[i].usef, 1); }
		else                    { CHKB(0, rectr.drt.points.a[i].usef, 0); }
	}
	for( i = 1; i < rectr.drt.nodes.a.size(); ++i ) {
		if( idxset1->exist(i) ) { CHKB(0, 0, rectr.drt.nodes.a[i].left); }
		else                    { CHKB(-1, rectr.drt.nodes.a[i].left, -1); }
	}
	return rc;
}
/*  ID_drt_check_all	|Cgƃm[h̋Ǘ̃`FbN
***************************************************************************/
int drt_check_all(
	RectTree &rectr)
{
	int rc, i, low[4], high[4];
	Xset_s idxset1, idxset2;
	DRTNode *wnod = &rectr.drt.nodes.a[0];
	//[0]̃ol͂Ô͂
	CHKB(0, wnod->type , 0);
	CHKB(-1, wnod->point, -1);
	CHKB(0, wnod->left , 0);
	CHKB(0, wnod->right, 0);
	CHKB(0, wnod->assocAVL, 0);
	CHKB(0, wnod->asocT, 0);
	//
	for( i = 0; i < 4; ++i ) { low[i] = INT_MIN; high[i] = INT_MAX; }
	rectr.drt.drtree_check1(0, rectr.drt.mainTree, 0, low, high);
	rectr.drt.check_balance(rectr.drt.mainTree);
	//؂Ƃ̃|CgW̃`FbN
	rc = check_point_set(rectr, &idxset1, &idxset2);
	//|Cgƃm[h̋Ǘ̃`FbN
	rc = check_empty_set(rectr, &idxset1, &idxset2);
	return rc;
}
/*  ID_test_create	create()̃eXg
***************************************************************************/
int test_create(RectTree &rectr, int num, int randnum)
{
	int rc, k;

	rectr.clear();
	for( k = 0; k < num; ++k ) 	{
		if( (rc = rectr.point_ins(k, poi[k])) < 0 ) goto                quit;
		if(dbgf[0]>1) Dprintf("test_create [%d] (%d,%d) (%d,%d)\n", k, poi[k][0], poi[k][1], poi[k][2], poi[k][3]);
	}
	rc = rectr.createTm(0);
//	rc = drt_check_all(sst);
//	if(dbgf[0]) dump_n1(sst);
//W	if(dbgf[0]>1) dump_nod(sst);
quit:
	return rc;
}
/*  ID_RectTree::isCross	`̏dȂ蔻
***************************************************************************/
int isCross(int *p, int X1, int X2, int Y1, int Y2 )
{
	return (p[0] <= X2 && p[1] >= X1 && p[2] <= Y2 && p[3] >= Y1);
}
/*  ID_RectTree::genQuestion
***************************************************************************/
int genQuestion(int req[][4], int n_req, int randnum)
{
	int w, k, x1, y1, x2, y2;
	for( k = 0; k < n_req; ++k ) {
#if 1 || ! defined(TAIRYO)
		x1 = rand() % randnum - randnum / 2; x2 = rand() % randnum - randnum / 2; if( x1 > x2 ) { w = x1; x1 = x2; x2 = w; }
		y1 = rand() % randnum - randnum / 2; y2 = rand() % randnum - randnum / 2; if( y1 > y2 ) { w = y1; y1 = y2; y2 = w; }
#else
		x1 = rand() % randnum; 	x2 = x1 + 1;
		y1 = rand() % randnum; 	y2 = y1 + 1;
#endif
		req[k][0] = x1; req[k][1] = x2; req[k][2] = y1; req[k][3] = y2;
	}
	return 0;
}
/*  ID_test_getnum	getnum()̃eXg
***************************************************************************/
int test_getnum(RectTree &rectr, int num, int randnum,
	time_t tm3[3])
{
	int rc = 0, i, k, x1, y1, x2, y2, n_ans, inf, loop, n_req;
	int req[10000][4];
//	SegTree &sst

	//T`FbN
	n_req = 10000;
	n_req = 1000;
	genQuestion(req, n_req, randnum);
	loop = 1;  //1000
	for( k = 0; k < loop; ++k ) {
		x1 = req[k][0]; x2 = req[k][1]; y1 = req[k][2]; y2 = req[k][3];
		n_ans = rectr.getnum( x1, x2, y1, y2, tm3, req, n_req);
		if(dbgf[8]) {
			rectr.check_ans(x1, x2, y1, y2);  //query̓̃`FbN
			inf = -1;
			for( i = 0; i < n_ans; ++i ) {
				inf = rectr.getinf(i);       CHKA(0, inf, num);
				rc= isCross(poi[inf], x1, x2, y1, y2); CHKB(1, rc, 1);
			}
		}
	}
	if(dbgf[8]) {
//		x1 = y1 = 0;
		x1 = y1 = (randnum - 1) * (-1);  //}CiX`FbN
		x2 = y2 = randnum - 1;
		n_ans = rectr.getnum(x1, x2, y1, y2, 0);    CHKB(num, n_ans, num);
		rectr.check_ans(x1, x2, y1, y2);  //query̓̃`FbN
	}
	return rc;
}
/*  ID_test_delete	del()̃eXg
***************************************************************************/
int test_delete(RectTree &rectr, int num, int randnum)
{
	int rc = 0, k, apoint;
	int insf[10000];
	                                       CHKB(1, num, 10000);
	for( k = 0; k < num; ++k) insf[k] = 1;
	//폜`FbN
	for( k = 0; k < 1000; ++k ) {
		apoint = rand() % num;
		if( insf[apoint] == 1 ) {
			insf[apoint] = 0;
			rc = rectr.delpoint(apoint, poi[apoint]);
			if(dbgf[8]) drt_check_all(rectr);
		}
	}
	for( apoint = 0; apoint < num; ++apoint ) {
		if( insf[apoint] == 1 ) {
			rc = rectr.delpoint(apoint, poi[apoint]);
			if(dbgf[8]) drt_check_all(rectr);
			insf[apoint] = 0;
		}
	}
//quit:
	return rc;
}
/*  ID_test_insert	drtree::ins()̃eXg
***************************************************************************/
int test_insert(RectTree &rectr, int num, int randnum)
{
//	int dim = 4;
	int rc, i, k, xx[4], poNo;

	rectr.clear();
	for( k = 0; k < num; ++k, ++poNo ) 	{
		poNo = k;
		for( i = 0; i < 4; ++i ) xx[i] = rand() % randnum - randnum / 2;
if( k == 0 ) { xx[0] = INT_MIN+1; xx[1] = INT_MAX-1; xx[2] = INT_MIN+1; xx[3] = INT_MAX-1; }
//if( k == 1 ) { xx[2] = INT_MIN+1; xx[3] = INT_MAX-1; }
//if( k == 2 ) { xx[0] = INT_MIN+1; xx[1] = INT_MAX-1; }
		if( xx[0] > xx[1] ) {rc = xx[0]; xx[0] = xx[1]; xx[1] = rc;}
		if( xx[2] > xx[3] ) {rc = xx[2]; xx[2] = xx[3]; xx[3] = rc;}
		rc = rectr.addpoint(poNo, xx);
		if(dbgf[8]) rc = drt_check_all(rectr);
	}
	return rc;
}
/*  ID_loop_insdel	geXg
***************************************************************************/
int loop_insdel(RectTree &rectr, int *insf, int num, int randnum, int loop)
{
	int /*dim = 4,*/ x1, x2, y1, y2;//low[4], high[4];
	int rc = 0, j, k, n_ans;

	for( j = 0; j < loop; ++j ) {
		k = rand() % num;
		if( insf[k] ) {
			insf[k] = 0;
			rc = rectr.delpoint(k, poi[k]);
			if(dbgf[8]) drt_check_all(rectr);
		} else {
			insf[k] = 1;
			rc = rectr.addpoint(k, poi[k]);
			if(dbgf[8]) rc = drt_check_all(rectr);
		}
		if(dbgf[8]) {
			x1 = rand() % randnum - randnum / 2; 	x2 = rand() % randnum - randnum / 2;
			y1 = rand() % randnum - randnum / 2; 	y2 = rand() % randnum - randnum / 2;
//			x1 = -x1; x2 = -x2; y1 = -y1; y2 = -y2;    //Să}CiX
			if( x1 > x2 ) {rc = x1; x1 = x2; x2 = rc;}
			if( y1 > y2 ) {rc = y1; y1 = y2; y2 = rc;}
			n_ans = rectr.getnum(x1, x2, y1, y2, 0);
		}
	}
	return 0;
}
/*  ID_test_insdel	geXg
***************************************************************************/
int test_insdel(RectTree &rectr, int num, int randnum)
{
	int rc = 0, k, loop;
	int insf[100000];

	loop = 1000;
	rectr.clear();
	if( num > 100000 ) num = 100000;
	for( k = 0; k < num; ++k) 	{
		insf[k] = 0;
	}
	rc = loop_insdel(rectr, insf, num, randnum, loop);
	return 0;
}
/*  ID_seino_ins_del2	drtree::ǉ/폜̐\eXg
***************************************************************************/
int seino_ins_del2(RectTree &rectr, int randnum)
{
	int numtb[] = {1, 2, 3, 10, 32, 100, 316, 1000, 3162, 10000, 31623, 100000 };
	int rc = 0, i, n_node, k, num, n_numtb, drtNode0, segtNode0, drtPsts, segtPsts;
	time_t now1, now2, now3; // i 0:VXe !=0:time()̌ʂw

//	Dprintf( "seino_ins_del2    num   insert   delete\n");
//	printf ( "seino_ins_del2    num   insert   delete\n");
Dprintf("                               (ߓ_)    ؐߓ_     pair       ǉ        폜      PST\n");
Dprintf("          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree                        DRTree  SEGTree  \n");
printf ("                               (ߓ_)    ؐߓ_     pair       ǉ        폜      PST\n");
printf ("          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree                        DRTree  SEGTree  \n");
	n_numtb = 10;
#if defined(TAIRYO)
	if(dbgf[8]== 0) n_numtb = 12;
#endif
	for( i = 0; i < n_numtb; ++i ) {
		rectr.clear();
		num = numtb[i];
		//ǉ
		now1 = clock();
		for( k = 0; k < num; ++k ) 	{
			rc = rectr.addpoint(k, poi[k]);
			if(dbgf[8]>1) rc = drt_check_all(rectr);
		}
		now2 = clock();
		int n_node_drt = 0, n_pair_drt = 0, num1, num2;
		int n_node_seg = 0, n_pair_seg = 0;
		num1 = rectr.drt.getNodeNum (&n_node_drt, &n_pair_drt);
		num2 = rectr.segt.getNodeNum(&n_node_seg, &n_pair_seg);

		rectr.node0psts( &drtNode0, &segtNode0, &drtPsts, &segtPsts );
//		Dprintf("drtNode0(%d) segtNode0(%d) drtPsts(%d) segtPsts(%d)\n", drtNode0, segtNode0, drtPsts, segtPsts );
		//폜
		if(dbgf[8]) rc = drt_check_all(rectr);
		n_node = rectr.drt.nodes.num;
		for( k = 0; k < num; ++k ) 	{
			rc = rectr.delpoint(k, poi[k]);
			if(dbgf[8]>1) rc = drt_check_all(rectr);
		}
		now3 = clock();
		if(dbgf[8]) rc = drt_check_all(rectr);
//		Dprintf( "              (%6d)(%7d)(%7d)\n", numtb[i], (int)(now2 - now1), (int)(now3 - now2) );
//		printf ( "              (%6d)(%7d)(%7d)\n", numtb[i], (int)(now2 - now1), (int)(now3 - now2) );
		Dprintf( "RectTree  num(%6d) nodes(%7d %7d)(%7d+%7d)(%7d+%7d)"
			, numtb[i], num1, num2, n_node_drt,n_node_seg, n_pair_drt,n_pair_seg);
		Dprintf( " cpu(%7d)(%7d)", (int)(now2 - now1), (int)(now3 - now2) );
		Dprintf("(%2d/%5d)(%2d/%5d)\n", drtNode0, drtPsts, segtNode0, segtPsts ); //PST
		printf ( "RectTree   num(%6d) nodes(%7d)(%7d)(%7d) cpu(%7d)(%7d)\n"
			, numtb[i], num1+num2, n_node_drt+n_node_seg, n_pair_drt+n_pair_seg, (int)(now2 - now1), (int)(now3 - now2) );
	}
	if(dbgf[8]) rc = drt_check_all(rectr);
	return rc;
}

/*  ID_seino_ins_del	ǉƍ폜̐\
***************************************************************************/
int seino_ins_del(RectTree &rectr, int randnum)
{
	int rc, k, i, num, n_numtb;
	int numtb[] = {1, 2, 3, 10, 32, 100, 316, 1000, 3162, 10000, 31623, 100000 };
	int insf[100000];

	time_t now1s, now1e;
	n_numtb = 10;
#if defined(TAIRYO)
	if(dbgf[8]== 0) n_numtb = 12;
#endif
	for( i = 0; i < n_numtb; ++i ) {
		rectr.clear();
		//
		for( k = 0; k < numtb[i]; ++k ) insf[k] = 0;
#if 1
		num = numtb[i] >> 1;
		for( k = 0; k < num; ++k ) 	{
			rc = rectr.point_ins(k, poi[k]);
			insf[k] = 1;
		}
		rc = rectr.createTm(0);
#endif
		//v
		now1s = clock();
		loop_insdel(rectr, insf, numtb[i], randnum, 100000);
		now1e = clock();

		Dprintf( "RectTree  num(%6d) insdel(%7d)\n", numtb[i], (int)(now1e - now1s));
		printf ( "RectTree  num(%6d) insdel(%7d)\n", numtb[i], (int)(now1e - now1s));
	}
	return 0;
}
/*  ID_test_nodesu	m[h
***************************************************************************/
int test_nodesu(RectTree &rectr, int randnum)
{
	int rc, k, i, num1, num2, n_numtb;
	int numtb[] = {1, 2, 3, 10, 32, 100, 316, 1000, 3162, 10000, 31623, 100000 };

	time_t now1s, now1e, now3s, now3e;
	time_t tmC[3], tmD[3];
//dbgf[0] = 1; //for test
Dprintf("                               (ߓ_)    ؐߓ_     pair       \z        T   \n");
Dprintf("          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree    DRTree SEGTree DRTree SEGTree\n");
printf("                               (ߓ_)    ؐߓ_     pair       \z        T   \n");
printf("          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree    DRTree SEGTree DRTree SEGTree\n");
	n_numtb = 10;
#if defined(TAIRYO)
	if(dbgf[8]== 0) n_numtb = 12;
#endif
	for( i = 0; i < n_numtb; ++i ) {
		//
		rectr.clear();
		for( k = 0; k < numtb[i]; ++k ) {
			rc = rectr.point_ins(k, poi[k]);
		}
		now1s = clock();
		rc = rectr.createTm(tmC);
		now1e = clock();
		//T
		now3s = now1e;
		tmD[0] = tmD[1] = tmD[2] = 0;
		test_getnum(rectr, numtb[i], randnum, tmD);
		now3e = clock();

		int n_node_drt = 0, n_pair_drt = 0;
		int n_node_seg = 0, n_pair_seg = 0;
		num1 = rectr.drt.getNodeNum (&n_node_drt, &n_pair_drt);
		num2 = rectr.segt.getNodeNum(&n_node_seg, &n_pair_seg);
		Dprintf( "RectTree  num(%6d) nodes(%7d %7d)(%7d+%7d)(%7d+%7d)"
			, numtb[i], num1, num2, n_node_drt,n_node_seg, n_pair_drt,n_pair_seg);
		Dprintf( " cpu(%6d %6d)(%6d %6d)\n"
			, (int)(tmC[2] - tmC[1]), (int)(tmC[1] - tmC[0]), (int)(tmD[2] - tmD[1]), (int)(tmD[1] - tmD[0]) );
		printf ( "RectTree   num(%6d) nodes(%7d)(%7d)(%7d) cpu(%6d %6d)(%6d %6d)\n"
			, numtb[i], num1+num2, n_node_drt+n_node_seg, n_pair_drt+n_pair_seg
			, (int)(tmC[2] - tmC[1]), (int)(tmC[1] - tmC[0]), (int)(tmD[2] - tmD[1]), (int)(tmD[1] - tmD[0]) );
//		Dprintf( "RectTree  num(%6d) nodes(%7d %7d)(%7d+%7d)(%7d+%7d) cpu(%6d)(%6d)\n"
//			, numtb[i], num1, num2, n_node_drt,n_node_seg, n_pair_drt,n_pair_seg, (int)(now1e - now1s), (int)(now3e - now3s) );
//		printf ( "RectTree   num(%6d) nodes(%7d)(%7d)(%7d) cpu(%6d)(%6d)\n"
//			, numtb[i], num1+num2, n_node_drt+n_node_seg, n_pair_drt+n_pair_seg, (int)(now1e - now1s), (int)(now3e - now3s) );
/*
	T(N)=N(logN)**c
	T(KN)=KN(logN+logK)**c=K(1+logK/logN)**c * T(N)
	K=10̎A      T(KN)=  10(1+  1/logN)**c * T(N)
	K=sqrt(10)̎AT(KN)=3.16(1+0.5/logN)**c * T(N)
*/
/*
//RECTTree	McCreight MSVC6 release Endeavor MT8000
                               (ߓ_)    ؐߓ_     pair        \z        T          \z        T(AQ)
          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree    DRTree SEGTree DRTree SEGTree     DRTree SEGTree DRTree SEGTree
RectTree  num(     1) nodes(      1       5)(      0+      1)(      0+      1) cpu(      0     0)(      0     0) cpu(      0     0)(      0     0)
RectTree  num(     2) nodes(      2       9)(      0+      4)(      0+      4) cpu(      0     0)(      0     0) cpu(      0     0)(      0     0)
RectTree  num(     3) nodes(      3      13)(      0+      4)(      0+      4) cpu(      0     0)(      0     0) cpu(      0     0)(      0     0)
RectTree  num(    10) nodes(     10      41)(     11+     24)(     11+     24) cpu(      0     0)(      0     0) cpu(      0     0)(      0     0)
RectTree  num(    32) nodes(     32     129)(     72+    134)(     72+    134) cpu(      0     0)(      0     0) cpu(      0     0)(     16     0)
RectTree  num(   100) nodes(    100     399)(    394+    580)(    394+    580) cpu(      0     0)(     15     0) cpu(      0     0)(      0     0)
RectTree  num(   316) nodes(    316    1249)(   1741+   2326)(   1741+   2326) cpu(      0     0)(     16     0) cpu(      0     0)(      0     0)
RectTree  num(  1000) nodes(   1000    3869)(   6999+   8904)(   6999+   8904) cpu(     16     0)(      0    15) cpu(      0     0)(     15    16)
RectTree  num(  3162) nodes(   3162   11573)(  28004+  33511)(  28004+  33511) cpu(     15    63)(     31    47) cpu(      0    31)(     32    47)
RectTree  num( 10000) nodes(  10000   29971)( 104536+ 119106)( 104536+ 119106) cpu(    125   219)(    109   172) cpu(     16    78)(    110   156)
RectTree  num( 31623) nodes(  31623   55959)( 378919+ 406155)( 378919+ 406155) cpu(    390   594)(    437   657) cpu(     94   250)(    422   625)
RectTree  num(100000) nodes( 100000   65391)(1384482+1299878)(1384482+1299878) cpu(   1188  1390)(   1594  2562) cpu(    407   797)(   1578  2468)
                               N    4N+1ȉ N(logN) N(logN)  N(logN) N(logN)        N(logN)**2     N(logN)**2
TԂ͒Z邽߂ɂPOOOJԂ
2012/05/30 
                               (ߓ_)    ؐߓ_     pair       \z        T     
          |Cg	     DRTree  SEGTree  DRTree  SEGTree  DRTree  SEGTree    DRTree SEGTree DRTree SEGTree   insert   delete
RectTree  num(     1) nodes(      1       5)(      0+      1)(      0+      1) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(     2) nodes(      2       9)(      0+      4)(      0+      4) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(     3) nodes(      3      13)(      0+      4)(      0+      4) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(    10) nodes(     10      41)(     11+     24)(     11+     24) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(    32) nodes(     32     129)(     72+    134)(     72+    134) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(   100) nodes(    100     399)(    394+    580)(    394+    580) cpu(     0      0)(     0     16)(      0)(      0)
RectTree  num(   316) nodes(    316    1249)(   1741+   2326)(   1741+   2326) cpu(     0      0)(    16      0)(      0)(      0)
RectTree  num(  1000) nodes(   1000    3869)(   6999+   8904)(   6999+   8904) cpu(     0      0)(    16     15)(     16)(     15)
RectTree  num(  3162) nodes(   3162   11573)(  28004+  33511)(  28004+  33511) cpu(    15     47)(    31     47)(    141)(     94)
RectTree  num( 10000) nodes(  10000   29971)( 104536+ 119106)( 104536+ 119106) cpu(   140    235)(    78    157)(    531)(    469)
RectTree  num( 31623) nodes(  31623   55959)( 378919+ 406155)( 378919+ 406155) cpu(   422    563)(   328    578)(   2328)(   2110)
RectTree  num(100000) nodes( 100000   65391)(1384482+1299878)(1384482+1299878) cpu(  1125   1172)(  1250   2328)(   9750)(   9187)
2012/06/11
RectTree  num(     1) nodes(      1       5)(      0+      0)(      0+      0) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(     2) nodes(      2       9)(      0+      3)(      0+      3) cpu(     0      0)(     0      0)(      0)(     15)
RectTree  num(     3) nodes(      3      13)(      0+      3)(      0+      3) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(    10) nodes(     10      41)(     11+     23)(     11+     23) cpu(     0      0)(     0      0)(      0)(     16)
RectTree  num(    32) nodes(     32     129)(     72+    133)(     72+    133) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(   100) nodes(    100     399)(    394+    579)(    394+    579) cpu(     0      0)(     0      0)(      0)(     16)
RectTree  num(   316) nodes(    316    1249)(   1741+   2325)(   1741+   2325) cpu(     0      0)(     0      0)(      0)(      0)
RectTree  num(  1000) nodes(   1000    3869)(   6999+   8903)(   6999+   8903) cpu(    15      0)(    16      0)(     16)(     15)
RectTree  num(  3162) nodes(   3162   11573)(  28004+  33510)(  28004+  33510) cpu(     0     16)(    31     31)(     63)(     62)
RectTree  num( 10000) nodes(  10000   29971)( 104536+ 119105)( 104536+ 119105) cpu(    31     63)(    78     78)(    297)(    344)
RectTree  num( 31623) nodes(  31623   55959)( 378919+ 406154)( 378919+ 406154) cpu(   125    250)(   313    312)(   1437)(   1625)
RectTree  num(100000) nodes( 100000   65391)(1384482+1299873)(1384482+1299873) cpu(   594    938)(  1641   1562)(   6578)(   6922)
*/
	}
	return 0;
}
#include <math.h>
void sigma_logNlogN()
{
	int i, k, num, n_numtb;
	double logNN[20];
	int numtb[] = {1, 2, 3, 10, 32, 100, 316, 1000, 3162, 10000, 31623, 100000 };
	n_numtb = 12;
#define LOGbeki(n) log((double)n) * log((double)n)
	for( i = 0; i < n_numtb; ++i ) {
		num = numtb[i];
		if( 0 ) { //(logN)**2
			for( logNN[i] = 0.0, k = 1; k < num; ++k ) logNN[i] += LOGbeki(k);
		} else { //N(logN)**2
			logNN[i] = num * LOGbeki(num);
		}
	}
	for( i = 0; i < n_numtb; ++i ) {
		printf ("N(%6d) (%10.1f)", numtb[i], logNN[i]);
		Dprintf("N(%6d) (%10.1f)", numtb[i], logNN[i]);
		if( i < 4 ) {
		} else if( i < n_numtb - 2 ) {
			printf (" 3*N(%5.2f) 10*N(%5.2f)", logNN[i+1] / logNN[i], logNN[i+2] / logNN[i]);
			Dprintf(" 3*N(%5.2f) 10*N(%5.2f)", logNN[i+1] / logNN[i], logNN[i+2] / logNN[i]);
		} else if( i < n_numtb - 1 ) {
			printf (" 3*N(%5.2f)", logNN[i+1] / logNN[i]);
			Dprintf(" 3*N(%5.2f)", logNN[i+1] / logNN[i]);
		}
		printf ("\n");
		Dprintf("\n");
	}
}
/*  ID_main	EXEC
***************************************************************************/
int main(int argc, char **argv )
{
	int num, rc, k, i, xx[4], n_poi;
	int randnum = 100000;
//	int randnum = 256;
	RectTree rectr; //敪؁{̈

	Dopen("sscDebugLog.txt");
	sscdbgin("sscdbg.flg");
	n_poi = sizeof(poi) / sizeof(poi[0]);
	for( k = 0; k < n_poi; ++k ) {
		for( i = 0; i < 4; ++i ) xx[i] = rand() % randnum - randnum / 2;
		poi[k][0] = (xx[0] < xx[1] ) ? xx[0] : xx[1]; //x1
		poi[k][1] = (xx[0] < xx[1] ) ? xx[1] : xx[0]; //x2
		poi[k][2] = (xx[2] < xx[3] ) ? xx[2] : xx[3]; //x1
		poi[k][3] = (xx[2] < xx[3] ) ? xx[3] : xx[2]; //x2
	}
	num = 350;   //m[h    17,391<==20,872<== 53,686
	num = 10000; //m[h 2,370,131                ==>
	num = 15;
	num = 100;   //m[h     2,119
	num = 250;
	num = 5;
	num = 1000;  //m[h    81,332<==         228,942
	num = 100;
//	sigma_logNlogN(); goto                        quit;
#if 1
	dbgf[8] = 1; //敪؂̓̃`FbN
	for( num = 1; num <= 100; ++num ) {
		//create()̃eXg
		rc = test_create(rectr, num, randnum);
		//getnum()̃eXg
		rc = test_getnum(rectr, num, randnum, 0);
		//del()̃eXg
		rc = test_delete(rectr, num, randnum);
		//ins()̃eXg
		rc = test_insert(rectr, num, randnum);
		//geXg
		rc = test_insdel(rectr, num, randnum);
	}
#endif
	dbgf[8] = 0; //敪؂̓̃`FbN
	rc = test_nodesu(rectr, randnum);
	rc = seino_ins_del2(rectr, randnum);
	rc = test_nodesu(rectr, randnum);
	rc = seino_ins_del2(rectr, randnum);
	goto                                  quit;
	rc = seino_ins_del(rectr, randnum);
	rc = seino_ins_del2(rectr, randnum);
	rc = test_nodesu(rectr, randnum);
//	rc = seino_ins_del(rectr, randnum);
quit:
	printf("end of test\n" ); fflush(stdout);
#if defined(_DEBUG)
	scanf("%c", &rc);
#endif
	return 0;
}
