/*
 * FILE     : segtree_query.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : g敪(augmented segment tree)
	[x,x]͓o^łȂ
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include "segtree.h"

/*  ID_SegTree::subQuery	anodeȉSans[]ɓo^
***************************************************************************/
int SegTree::subQuery(  //>=0:ǉ`̐
	int anode,       //i       node[]
	int lrOpen,      //i JԎw 1: 2:E 3: J 0:
//	SegCoord &q,     //i
	int *xyy,         //i
	VECTOR<int> &ans0)    //o
//	Xset_s &ans0)    //o
{
	int rc = 0, apoint, inf;

	if( anode > 0 ) {
		if( nodes.a[anode].asocT > 0 ) {
			//first	x1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
			PSTreeAsoc &asoct = psts.ary[nodes.a[anode].asocT];
#if 1
			asoct.side3Query(INT_MIN, xyy[2], xyy[1], xsortwk, usecnt);
			for( inf = 0; inf < xsortwk.size(); ++inf ) {
				apoint = xsortwk[inf];              CHKA(0, apoint, points.a.size());
	//			ans.push(apoint); ++rc;
				ans.push_back(apoint); ++rc;
			}
#else
			for( apoint = asoct.firstAns(&inf, INT_MIN, xyy[2], xyy[1]); apoint >= 0; apoint = asoct.nextAns(&inf) ) {
	//		for( apoint = asoct.firstAns(&inf, INT_MIN, q.y2, q.y1); apoint >= 0; apoint = asoct.nextAns(&inf) ) {
	//		for( apoint = asoct.first(0, q.y2, q.y1); apoint >= 0; apoint = asoct.next() ) {
	//			ans.push(apoint); ++rc;
				ans.push_back(apoint); ++rc;
				//apoint 񍐂ׂǂׂifobOpj
				if(dbgf[8]) {
					if( SegCoord::isCross(lrOpen, points.a[apoint], xyy) ) {
					} else { //ɂ͗Ȃ͂
						apoint = apoint; CHKA(0, apoint, -571);
					}
				}
			}
#endif
		}
	}
	return rc;
}
/*  ID_SegCoord::isCross	
***************************************************************************/
int SegCoord::isCross(
	int lrOpen,      //i JԎw 1: 2:E 3: J 0:
	SegCoord &p,
	int *xyy)
{
	int cross = 1;
	//敪؂̋h(q.x1)̉B
//	if(  q.x1 < p.x1 ||  q.x1 == p.x1 && (lrOpen & 1) ) cross = 0; //NT120601
//	if(  p.x2 < q.x1 ||  p.x2 == q.x1 && (lrOpen & 2) ) cross = 0; //NT120601
	if(  xyy[0] < p.x1   ||  xyy[0] == p.x1   && (lrOpen & 1) ) cross = 0;
	if(  p.x2   < xyy[0] ||  p.x2   == xyy[0] && (lrOpen & 2) ) cross = 0;
	//t؂Œ`ƂdȂ邩
	if( cross )
//		cross =  (p.x1 <= q.x2 && p.x2 >= q.x1 && p.y1 <= q.y2 && p.y2 >= q.y1);
		cross =  (p.y1 <= xyy[2] && p.y2 >= xyy[1]);
	return cross;
}
/*  ID_SegTree::stabbingQuery	敪؂̋h
***************************************************************************/
int SegTree::stabbingQuery(
	int anode,       //i       node[]
	int lrOpen,      //i o^̊JԎw 1: 2:E 3: J 0:
//	SegCoord &p,     //i ̈
	int *xyy,        //i ̈
	int xx,          //i hW
	VECTOR<int> &ans0)    //o
//	Xset_s &ans0)    //o
{
	int rc;
	SegNode *vnode;
	if( anode <= 0 ) {
	} else {
		//ߓ_anodeɓo^ĂSĕ񍐂Brc:ǉ
		rc = subQuery(anode, lrOpen, xyy, ans0);
		vnode = &nodes.a[anode];
		if( xx < vnode->key ) {
				stabbingQuery(vnode->left , lrOpen, xyy, xx, ans0);
		} else if( xx > vnode->key ) {
			stabbingQuery(vnode->right, lrOpen, xyy, xx, ans0);
		} else { //xx == vnode->key
			if( (lrOpen & 2) == 0 ) //o^̉E[͕
				stabbingQuery(vnode->left , lrOpen, xyy, xx, ans0);
			if( (lrOpen & 1) == 0 ) //o^̍[͕
				stabbingQuery(vnode->right, lrOpen, xyy, xx, ans0);
		}
	}
	return 0;
}
/*  ID_SegTree::getAnsNum	low <= p <= high̃|CgԂ
***************************************************************************/
int SegTree::getAnsNum(
	int lrOpen,      //i JԎw 1: 2:E 3: J 0:
	int x0, int y1, int y2)
{
	int xyy[3];
	xyy[0] = x0; xyy[1] = y1; xyy[2] = y2; 
//	SegCoord q(0, x0, y1, y2);
	ans.clear();
	//low <= q <= high̃m[h̃Xg
//	stabbingQuery(root, lrOpen, q, q.x1, ans); //_ŋh
	stabbingQuery(root, lrOpen, xyy, x0, ans); //_ŋh
	if(dbgf[8]) check_ans(lrOpen, xyy);  //query̓̃`FbN
	return ans.size();
}
/*  ID_SegTree::getAnsInf	Ԗڂ̓_̔ԍԂ getinf()
***************************************************************************/
int SegTree::getAnsInf( //>=0:_̔ԍ -1:I
	int k)              //ŏ-1ŌĂ
{
	int rc;
//	if( k < 0 ) rc = ans.first();
//	else  rc = ans.next(k);
	if( k < 0 ) rc = ans[0];
	else  rc = ans[k];
	return rc;
}
/*  ID_SegTree::countActine	ANeBum[h̒
***************************************************************************/
int SegTree::countActive(
	int anode, int *active, int *nnode)
{
	SegNode *vnode;
	int actL, nndL, actR, nndR;
	*active = *nnode = 0;
	if( anode == -2 ) anode = root;
	if( anode <= 0 ) {
	} else {
		vnode = &nodes.a[anode];
		countActive(vnode->left , &actL, &nndL);
		countActive(vnode->right, &actR, &nndR);
		*active = actL + actR;
		*nnode  = nndL + nndR + 1;
		if( vnode->asocT != 0 ) {
			PSTreeAsoc &asoct = psts.ary[vnode->asocT];
			if( asoct.size() > 0 || actL + actR > 0)
				++(*active);
		}
	}
	return 0;
}
/*  ID_SegTree::getNodeNum	nodes.numԂBPSTm[hݒ
***************************************************************************/
int SegTree::getNodeNum(
	int *pstNodeNum, int *pstPairNum)
{
	int rc, k;

	*pstNodeNum = *pstPairNum = 0;
	for( k = 1; k < psts.n_ary; ++k ) {
		if( psts.ary[k].emptyNext >= 0 ) continue;
		if( psts.ary[k].n_node == 0 ) 	continue;  //ƂŒׂ
//		*pstNodeNum += psts.ary[k].nodes.num;
		*pstNodeNum += psts.ary[k].n_node;
		*pstPairNum += psts.ary[k].n_pair;
	}
	rc = nodes.num;
if( dbgf[0] ) Dprintf("n_ary(%d)rc(%d)pstNodeNum(%d)emptyNext(%d)\n", psts.n_ary, rc, *pstNodeNum, *pstPairNum);
	return rc;
}
