/*
 * FILE      : xqsort.h
 * FUNCTION  : classɂz̓YXg\[g֐ev[g(o֐|C^̎gp)
 * Copyright (C) 2011 Sogen System Co., Ltd
 * AUTHER    : 2011/06/12 N.Tsuchiya
      yz
      r֐ɃNX̃o֐gpB
	  YrL[ɒǉ̂ŁAlL[LĂ\[gԂ͉e󂯂ȂB
	  iqsort()ł͂Qlf[^O(N**2)ɂȂj
	  l̃f[^͕̏ۑBqsort()ł͕ۑȂB
      PR[h̃obt@gƂswapɃf[^]񐔂Q/RɌ炵Ă
   NT120526 lL[炯ł\ێB
 */
/*------------------------  gp
#include <vector>
using namespace std;
class node {
	int x, y;  //_̍Wl
public:	       //compA()F{staticr֐B_̍Wlr(K{ł͂Ȃ)
	static int compA(const node &p,const node &q){ //<== staticYȂ
		if     ( p.x < q.x ) rc = -1;
		else if( p.x > q.x ) rc = 1;
		else if( p.y < q.y ) rc = -1;
		else if( p.y > q.y ) rc = 1;
		else rc = 0;
		return rc;
	}
};
class tree {
	vector<node> pairs;  //\̔z
public:
	int comp1(const int *p,const int *q){ //xqsort()ɓn\[gpr֐(K{)
		return node::compA(pairs[*p], pairs[*q]);}
	int comp2(const int *p,const int *q){ //xqsort()ɓn~\[gpr֐(K{)
		return node::compA(pairs[*q], pairs[*p]);}
};
int main()
{
	tree t;
	vector<int> idxList;                       //\̔z̓YXg
	//Ń\[gf[^쐬
	for( int i = 0; i < t.pair_size(); ++i )   //\̔z̓YXgB
		idxList.push_back(i);
	xqsort(&idxList[0], 3, t, &tree::comp1); //\̔z̓YXg\[g
	xqsort(&idxList[0], 3, t, &tree::comp2); //\̔z̓YXg\[g
}
*/
#include <assert.h>

template <class D, class C>  //D͒ʏint or size_t ŔzỸf[^^
void xqsort(
	D *ary,       //io int or size_t ̃\[gΏۂ̓YzB
	size_t n_ary, //o  \[gΏۃf[^
	C &t,         //i  NXIuWFNg
	int (C::*p_comp)(const D*,const D*) ) //i  rp̃o֐
{
    register size_t lok, hik;
    register D midkey;
    size_t lo, hi, mid, lostk[64], histk[64];
	int n_stk, cmp;

	if( n_ary >= 2 ) {
		n_stk = 0;
		lo = 0; hi = n_ary - 1;           //\[gԁF[lo,hi]
		for( ; ; ) { assert(lo < hi); //Qȏf[^͂
			if( lo + 1 == hi ) {   //f[^Q̏ꍇBԐς炸
				if( (cmp = (t.*p_comp)( &ary[lo], &ary[hi])) == 0 )
					cmp = ary[lo] - ary[hi];
				if( cmp >0 ) {
					midkey = ary[hi]; ary[hi] = ary[lo]; ary[lo] = midkey;//
				}
				if( --n_stk < 0 ) break;
				lo = lostk[n_stk], hi = histk[n_stk]; //
				continue;
			}
			mid = lo + ((hi - lo) >> 1);   //(lo+hi)̃I[ot[l
			midkey   = ary[mid];            //̒lL[ƂB
			ary[mid] = ary[lo];             //ary[lo]󂯂
			lok = lo; hik = hi;
			for( ; ; ) {
				for( ; lok < hik; --hik )   //L[菬̂T
					if( (cmp = (t.*p_comp)( &ary[hik], &midkey)) < 0 ) break;
					else if( cmp == 0 && ary[hik] < midkey ) break;
				if( lok == hik ) break;     //ifVC6+BoundsCheckerŃN NT120523
				ary[lok] = ary[hik];        //ary[hik]͋󂫂ɂȂB
				for( ; lok < hik; ++lok )   //L[傫̂T
					if( (cmp = (t.*p_comp)( &ary[lok], &midkey)) > 0 ) break;
					else if( cmp == 0 && ary[lok] > midkey ) break;
				if( lok == hik ) break;     //ifVC6+BoundsCheckerŃN NT120523
				ary[hik] = ary[lok];        //ary[lok]͋󂫂ɂȂB
			}   assert(lok == hik);         //lok == hik̂͂
			ary[lok] = midkey;              //L[󂫂ɖ߂Bary[lok]͋󂫁Blok == hik
			//̃\[gԁF[lo, hik-1] [hik+1,hi] (lok = hik)
			if( hik > mid ) {  assert(hik-lo >= hi-hik); //傫(lo)X^bNɓ
				if( hik + 1 < hi ) { assert(n_stk<64); //ZɂQȏf[^
					lostk[n_stk] = lo; histk[n_stk] = hik - 1; ++n_stk; //X^bNɓāAォ\[g
					lo  = hik + 1;          //lo:󂫂̈ʒu
				} else if( lo + 1 < hik ) { //Z̓\[gsvBɂQȏf[^
					hi = hik - 1;
				} else {
					if( --n_stk < 0 ) break; //X^bNɂȂI
					lo = lostk[n_stk], hi = histk[n_stk]; //
				}
			} else { assert(hik-lo <= hi-hik);
				if( lo + 1 < hik) { //assert(n_stk<64); //ZɂQȏf[^
					lostk[n_stk] = hik + 1; histk[n_stk] = hi; ++n_stk; //X^bNɓāAォ\[g
					hi = hik - 1;
				} else if( hik + 1 < hi ) { //Z̓\[gsvBɂQȏf[^
					lo = hik + 1;
				} else {   //̒Pȉ
					if( --n_stk < 0 ) break; //X^bNɂȂI
					lo = lostk[n_stk], hi = histk[n_stk]; //
				}
			}
		}
	}
#if defined (_DEBUG)
	for (n_stk = 1; n_stk < (int)n_ary; n_stk++) {
		if( (cmp = (t.*p_comp)(&ary[n_stk-1], &ary[n_stk])) == 0 )
			cmp = ary[n_stk-1] - ary[n_stk];
		if( cmp >= 0) {
			printf("\[głĂȂ\n");
			break;
		}
	}
#endif
}
