/*
 * FILE     : drtree.h
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : c̈(D-dimension range tree){q[vT(Priority Search Tree:PST)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
#if ! defined(DRTREE_H)
#define DRTREE_H

#include "ssc.h"
#include "drtree_memo.h"
#include "drpstree_memo.h"

#if 0 //1:<vector>g 0:"sscvect.h"g
#   include <vector>
#   define VECTOR vector
    using namespace std;
#else
#   include "sscvect.h"
#   define VECTOR sscvect
#endif
#include "assoc_pstree.h" // t\pB
#include "McCreight1.h" // McCreght (Place Holderŋp)

#define Empty  0
#define		E 0          /* oXx E: EB*/
#define		L -1         /* oXx L: ɌXĂB*/
#define		R 1          /* oXx R: EɌXĂB*/

struct DRTPoint {         //̃|Cg  points.a[0]͎g
	int		no;           //|Cg̔ԍBʁADRTPoints.a[]YƓ NT110709add
	int 	topX;         //xNgw̐擪ʒu 0:x[]m                x[]
	int		usef;         // 0:, 1:gp
	DRTPoint() : topX(0), usef(0){}
} ;
struct DRTPoints {        //̃|Cg̏WBpoints.a[0]g
	int num;              //󂫂܂߂ă|Cg
	int dim;              //
	VECTOR<int>   x;      //̍Wl̔z x1...xn (x[0] ͏ =0 ŖgpƂ)
	VECTOR<DRTPoint> a;       //̃|Cg̔zB
	DRTPoints() : num(0), dim(0) { x.push_back(0); }   //RXgN^
	~DRTPoints(){}                                //fXgN^
	int clear();
	int find(int no, int *x);
	DRTPoint& get(int idx);
	int getLast2(int idx, int *pn, int *px, int *py){
		DRTPoint& pnt = a[idx]; *pn = pnt.no;
		*px = x[pnt.topX + dim - 2];
		*py = x[pnt.topX + dim - 1];
		return 0;
	}
	friend struct DrTrees;
private:
	int ins(int dim, int no, int *x);
	int del(int idx);
} ;
struct DRTNode {          //̈؂̐ߓ_ nodes.a[0]͎gȂ
	int point;            //                                                    point[]
	int left ;            //-1:                                               nodes.a[]
	int right;            //͎̎̋B擪DRTNodes::emptyTop            nodes.a[]
//h	int hight;            //q؂̍ 1:leaf
	int assocAVL;         //t؁BDRTreeB0:tؖ                        nodes.a[]or0
	int asocT;            //t؁BPSTreeB0:tؖ                        psts.ary[]or0
	char type;        /* oXx L: ɌXĂB R: EɌXĂBE: EB*/
	DRTNode() : type(0), point(-1), left(0), right(0), assocAVL(0), asocT(0) /*,emptyNext(0), oya(0), hight(0), level(0)*/ {}
} ;
struct DRTNodes {         //̈؂̐ߓ_̏W
	int num;              //󂫂ߓ_
	int emptyTop;         //擪̋󂫐ߓ_BnextDRTNode::right                nodes.a[]
	VECTOR<DRTNode> a;    //̈؂̐ߓ_̔z
	DRTNodes() : num(0), emptyTop(0){ a.push_back(DRTNode()); }   //RXgN^
	~DRTNodes(){}                                //fXgN^
	int clear();
	int ins(int oya, int left, int right, int apoint, int aasoc, int level);
	int setval(int anode, int oya, int left, int right, int apoint, int aasoc);
	int del(int idx);
	DRTNode& get(int idx);
} ;
struct DRTIntVectPool {       //ꗗ쐬Ɏgvect<int>̏W NT110719add
	VECTOR<VECTOR<int>*> vctPool;      //
	int useMax;
	DRTIntVectPool():useMax(0){}
	~DRTIntVectPool() {
		for(int i = useMax - 1; i >= 0; --i ) delete vctPool[i]; }
#if 0
	VECTOR<int> *newVect(int level) { VECTOR<int> *rc;
		if( vctPool.size() > 0 ) {
			rc = vctPool[vctPool.size() - 1];
			vctPool.pop_back(); }
		else {
			rc = new VECTOR<int>(); }
		rc->clear();
		return rc; }
	void delVect(VECTOR<int> *h) {
		vctPool.push_back(h);
		if( useMax < vctPool.size() ) useMax = vctPool.size();}
#else
	VECTOR<int> *newVect(int level) { VECTOR<int> *rc;
		while( vctPool.size() <= level ) {
			rc = new VECTOR<int>();
			vctPool.push_back(rc);
			useMax = level;
		}
		rc = vctPool[level];
		rc->clear();
		return rc; }
	void delVect(VECTOR<int> *h) {}
#endif
} ;
struct DrTrees {              //̈
	PSTrees psts;             //PSTreȅW NT120419
	int mainTree;             //ŏʖ؂̍m[h                 nodes.a[]
	int dim;                  //
	DRTNodes  nodes;
	DRTPoints points;
	VECTOR<int> ans;          //point[] i[
	VECTOR<int> oya1;         //mearge()pAside3Query()p
	VECTOR<int> oya2;         //mearge()pAside3Query()p
	VECTOR<int> pListC;                   //DrTreescreate(),check_ans()pB points.a[]̔z
	VECTOR<int> pListL;                   //PSTreemearge()pB points.a[]̔z
	VECTOR<int> pListR;                   //PSTreemearge()pB points.a[]̔z
	DRTIntVectPool vectPool;   //ꗗ쐬Ɏgvect<int>̏W NT110719add
	DrTrees() : mainTree(0),dim(0) { }   //RXgN^
	~DrTrees(){}                                //fXgN^
	//̈؂čėp\ɂ
	int clear();
	//P̓__WɒǉBcreate()Ăō̈؂ꊇ\
	int point_ins(int dim,int poNo,int *xi); //dimׂ͂ēƁBpoNôQd`͕sB
	//̈؂ꊇ\B
	int create();
	//̈؂ɓIɂP̓_ǉ
	int addpoint(int dim, int ndNumber, int *pnt);
	//̈؂瓮IɂP̓_폜
	int delpoint(int no);
	//low <= p <= high̓_̐Ԃ
	int getnum(int *low, int *high);
	//Ԗڂ̓_̔ԍԂ
	int getinf(int k);
	//̈؂̃`FbNPioXȊOj
	int drtree_check1(int level,int anod, int oyanod, int *low,int *high);
	//̈؂̃`FbNQioX̂݁j
	int check_balance(int anod);
	//
	int getNodeNum(int *pstNodeNum, int *pstPairNum); //nodes.numԂBPSTm[hݒ
private:
	int compPoint0(const int *p, const int *q);
	int compPointL(int level,const int p, const int q);
	int compVectLE(int level, int *p,int *q);
	int compElem(int level, int *p,int *q);
	int avlNext(int rootnd,int anode,VECTOR<int> &oyas);
	int Build2DRangeTree(int level,int oyaNode,int num,int *Plist,int *hi,int rootf);
	int mearge(int level, int oya);
	int DrTrees::leafTest(int level,int anode,int *low,int *hight);
	int nextLevelRangeQuery(int level,int anode,int *low,int *high);
	int D1RangeQuery(int anode);
	int DRangeQuery(int level,int root,int *low, int *high);
	int FindSplitNode(int level,int root,int *low,int *high );
	int check_ans(int *low,int *high);
	int Bitr_add(int level, int pnod, int oyanod, int pntidx, int *addfg);
	int Bitr_del(int level,int apoin,int aroot,int *delfg,int *fndfg );
	int Bitr_balL(int level,int aroot,int *addfg,int *delfg );
	int Bitr_balR(int level,int aroot,int *addfg,int *delfg );
//	int Bitr_unlnk(int level,int q,int *left,int *addf,int *delfg );
	int Bitr_unlnk(int level,int q,int left,int *addf,int *delfg );
	int del_assocAVL(int level, int assoc);
	int del_assoc(int level, int np);
	int del_assoc_point(int level,int nr,int pp);
	int rotate_single_assoc(int level,int np,int p1);
	int rotate_double_assoc(int level,int np,int p1,int p2);
	int add_assoc_point(int level,int oyaNode,int pnode,int pp);

	int subQuery(int level,int anode,int *low,int *high);
//	int makePairList( int level, int anode, VECTOR<PSTreeAsoc::BPSTpair> *pairList);
	int makePairList( int level, int anode, VECTOR<int> *pairList, int *num);
	int makePstPair(int level,int apoin,PSTreeAsoc::BPSTpair *wPair);
	int meargePst(int level, int oya);
	
} ;

#endif //! defined(DRTREE_H)
