/*
 * FILE     : drtree_2.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : ̈(D-dimension range tree)
 * AUTHER   : N.Tsuchiya  2010.05.27
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "drtree.h"
#include "xqsort.h"
//DRTPoints *po;  //qsort()̔r֐p̃t@CO[oB
//static int lsLevel;

/*  ID_compPointL	|CgrBï؍쐬AXVpj
***************************************************************************/
int DrTrees::compPointL(
	int level,
	const int p, const int q) //point[]
{
	int rc;
//	rc = points.x[level + points.a[p].topX] - points.x[level + points.a[q].topX];
	if     ( points.x[level + points.a[p].topX] < points.x[level + points.a[q].topX] ) rc = -1;
	else if( points.x[level + points.a[p].topX] > points.x[level + points.a[q].topX] ) rc = 1;
	else rc = p - q; //ꍇ̓|CgԍŔrČʂӂɂ
//	if( rc == 0 ) CHKA(0, rc, -1);
	return rc;
}
/*  ID_compPoint0	|CgrBixqsort()pAP̂݁j
***************************************************************************/
int DrTrees::compPoint0(
	const int *p, const int *q) //point[]
{
	int rc;
//	rc = points.x[points.a[*p].topX] - points.x[points.a[*q].topX];
	if     ( points.x[points.a[*p].topX] < points.x[points.a[*q].topX] ) rc = -1;
	else if( points.x[points.a[*p].topX] > points.x[points.a[*q].topX] ) rc = 1;
	else rc = *p - *q; //ꍇ̓|CgԍŔrČʂӂɂ
	return rc;
}

/*  ID_Build2DRangeTree	̈؂\B
***************************************************************************/
int DrTrees::Build2DRangeTree( //r Nodes[]YԂ
	int level,      //i ̈؂̃x 0:
	int oyaNode,    //i em[hԍB؂̍ꍇ́Aʖ؂̃m[hԍ   node[]
	int nPlist,     //i Plist̃|CgBO
	int *Plist,     //i \[gς݂̃|Cg̔z
	int *hi,        //o ؂̍Btm[h̍͂PD
	int rootf)      //i 1: 0:/t B؂̍ɂ͓؂Ȃ
{
	int rc, p, vleft, vright, anode, apoin, numL, numR, hiL, hiR, assoc;

	if( nPlist <= 0 ) {   //CHKB(1, 1, nPlist);
		//@ if P P_̂then
		//̓_i[tv C؂̒Pm[h̖؂ƂĈv ̓Tassoc ƂD
		anode = 0;
		*hi = 0;
	} else if( level >= dim ) {    CHKA(0, level, dim);
		anode = 0;
	} else if( nPlist == 1 ) { //tɂ͓؂Ȃ
		apoin = Plist[0];              CHKA(0, apoin, points.a.size());
		anode = nodes.ins(oyaNode, 0, 0, apoin, 0, level);
//h		hight = 1;
		*hi = 1;
//h		nodes.setval(anode, oyaNode, 0, 0, apoin, hight);
		nodes.setval(anode, oyaNode, 0, 0, apoin, 0);
		//nodes.a[anode].assoc = 0;
	} else {
		//B P x W̒Ԓl_p Pleft Pright ɂQC
		p = nPlist / 2;
		//debug ==========================>> `FbN̂
		if(dbgf[8]) {
			for( int i = 1; i < nPlist; ++i ) {
				rc = compPointL( level, Plist[i - 1], Plist[i]); CHKB(rc, rc, -1);
			}
		}
		//debug <<==========================
		numL = p;
		numR = nPlist - p - 1;
		apoin = Plist[p];              CHKA(0, apoin, points.a.size());
		anode = nodes.ins(oyaNode, 0, 0, apoin, 0, level);
		//C vleft ? Build2DRangeTree(Pleft)
		vleft = Build2DRangeTree(level, anode, numL, Plist, &hiL, 0);
		//D vright ? Build2DRangeTree(Pright)
		vright = Build2DRangeTree(level, anode, numR, Plist + p + 1, &hiR, 0);
		//E p ɑΉm[hv Clc(v)  vleft, rc(v)  vright ƂĎ؂
		*hi = 1 + ((hiL > hiR) ? hiL : hiR);      //h CHKB(*hi, hight, *hi);
		nodes.a[anode].type = hiR - hiL;      CHKB(-1, hiR - hiL, 1);   // oXx L(-1):ɌXĂ R(+1):E E(0):
		nodes.setval(anode, oyaNode, vleft, vright, apoin, 0);
		//F Tassoc(lc(v) Tassoc(rc(v) }[W, v ǉTassoc(v) 
		nodes.a[anode].assocAVL = 0;
		nodes.a[anode].asocT = 0;
		if( rootf ) {            //؂̍ɂ͓؂Ȃ
		} else if( level + 1 >= dim - 1 ) { CHKA(level, dim, -571) //ŉʂ̖؂̃m[hɂ͓؂͖
		} else if( level + 2 >= dim - 1 ) {    //ŉ̂Qi͂ors
			assoc = meargePst(level + 1, anode); //meargePst()nodes[]̃AhX
			nodes.a[anode].asocT = assoc;        //ς̂łQsɕH //YS120502
		} else {
			assoc = mearge(level + 1, anode); //YS120502
			nodes.a[anode].assocAVL = assoc;
		}
	}
	//G v Ԃ
	//^ꂽʂ̓_WP ƂBuild2DRangeTree(P) Ăׂ΁C
	//Q̈T (؂Ɠؓ) 珇ɍċAIɍ\C
	//̃[gm[hւ̃|C^ԂD
	return anode;
}
/*  ID_DrTrees::avlNext	`uk؂玟̒lԂB̒l͂OԂBoya|C^gȂ
***************************************************************************/
int DrTrees::avlNext( //r ̃m[hԍ 0:I
	int rootnd,       //i AVL؂̍m[h                    node[]
	int anode,        //i ߓ_ -1:擪m[hv 0:I                    node[]
	VECTOR<int> &oyas) //mearge()p
{
	int konode, nd;
	 if( anode < 0 ) {
		//AVL؍ŏl̃m[hTB
		oyas.clear();         //
		for( nd = rootnd; nd > 0; nd = nodes.a[nd].left) {
			if( nodes.a[nd].left <= 0 ) break;
			oyas.push_back(nd);
		}
	} else {                            CHKA(1, anode, nodes.a.size());
		//TFE؂̍ŏm[hAE؂́Am[hƂȂĂŏ̐em[hB
		if( nodes.a[anode].right > 0 ) {
			oyas.push_back(anode);
			for( nd = nodes.a[anode].right; ; nd = nodes.a[nd].left ) {
				if( nodes.a[nd].left <= 0 ) break;
				oyas.push_back(nd);
			}
		} else {
			for( konode = nd = anode; oyas.size() > 0; konode = nd ) {
//				nd = oyas.back();
				nd = oyas[oyas.size()-1];
				oyas.pop_back();
				if( konode == nodes.a[nd].left ) break;
				if( konode != nodes.a[nd].right ) break;  //؂̍m[hoyaɏʖ؂̃m[hԍĂ
			}
			if( konode != nodes.a[nd].left ) nd = 0;
		}
	}
	return nd;
}
/*  ID_DrTrees::mearge	lc(v)Tassoc(rc(v) }[W, v ǉTassoc(v) 
***************************************************************************/
int DrTrees::mearge(  //r
	int level,        //i 0..dim-1B0:
	int oyaNode)      //i eߓ_@0:ŐeȂ               node[]
{
	int anode, bnode, oyaPoint, minAssoc, nPlist, apoin, bpoin, oyaComp;
	int assocL, assocR, hi, vleft, vright;
	VECTOR<int> &sortwk = *vectPool.newVect(level); CHKB(0, sortwk.size(), 0);
	sortwk.resize(points.a.size()); //NT110413add
	int *Plist = &sortwk[0];
	int maxP = sortwk.size();
	vleft  = nodes.a[oyaNode].left;
	vright = nodes.a[oyaNode].right;
	assocL = nodes.a[vleft ].assocAVL;
	assocR = nodes.a[vright].assocAVL;
	//assocL, assocR, oyaNode\[gς݃|CgXg𓾂
	//assoc̍ŏl̃m[hTB
	anode = (assocL > 0) ? avlNext(assocL, -1, oya1) : 0;
	bnode = (assocR > 0) ? avlNext(assocR, -1, oya2) : 0;
	//tm[hɂ͓؂Ȃ̂ŁAem[h̃|Cg擾
	apoin = (assocL <= 0) ? nodes.a[vleft ].point : nodes.a[anode].point;
	bpoin = (assocR <= 0) ? nodes.a[vright].point : nodes.a[bnode].point;
	oyaPoint = nodes.a[oyaNode].point;   CHKB(1, 1, oyaNode);
	nPlist = 0;
//	po = &points;  //qsort()̔r֐p̃t@CO[oBKS110318
	//assoc̃m[hɎoȂARA}[WB
	while( apoin >= 0 || bpoin >= 0 ) {
		if       ( apoin < 0 ) { minAssoc = 1;
		} else if( bpoin < 0 ) { minAssoc = -1;
		} else { minAssoc = compPointL(level, apoin, bpoin);
		}
		if( oyaPoint >= 0 ) {
			if( minAssoc > 0 ) {
				oyaComp = compPointL(level, oyaPoint, bpoin);
			} else if( minAssoc < 0 ) {
				oyaComp = compPointL(level, oyaPoint, apoin);
			} else { oyaComp = 0; CHKB(1, minAssoc, -1); }
			if( oyaComp < 0 ) {         CHKA(0, nPlist, maxP);
				if( nPlist < maxP ) Plist[nPlist++] = oyaPoint;
				oyaPoint = -1;
			}
		}
		if( minAssoc > 0 ) {            CHKA(0, nPlist, maxP);
			if( nPlist < maxP ) Plist[nPlist++] = bpoin;
			bnode = (assocR > 0) ? avlNext(assocR, bnode, oya2) : 0;
			bpoin = nodes.a[bnode].point; //nodes.a[0].point = -1Ă
		} else if( minAssoc < 0 ) {      CHKA(0, nPlist, maxP);
			if( nPlist < maxP ) Plist[nPlist++] = apoin;
			anode = (assocL > 0) ? avlNext(assocL, anode, oya1) : 0;
			apoin = nodes.a[anode].point; //nodes.a[0].point = -1Ă
		} else                      CHKB(1, minAssoc, -1);
	}
	if( oyaPoint >= 0 ) {               CHKA(0, nPlist, maxP);
		if( nPlist < maxP ) Plist[nPlist++] = oyaPoint;
		oyaPoint = -1;
	}
	if( nPlist > 1 ) { //tm[hɂ͓؂͍Ȃ
		//̈؂\B
		anode = Build2DRangeTree(level, oyaNode, nPlist, Plist, &hi, 1);
	} else {
		anode = 0;
	}
	vectPool.delVect(&sortwk);
	return anode;
}
/*  ID_DrTrees::makePairList	ߓ_̓؂yȀt̃XgB؂ꍇ͐ߓ_yAB
***************************************************************************/
int DrTrees::makePairList(  //r
	int level,        //i 
	int anode,        //i ߓ_@               node[]
	VECTOR<int> *pairList,  //o compX()ŏtꂽpair̔zB points.a[]̔z
	int *npoin)       //o
{
	int i, apoin, apsts, rtc;
	PSTreeAsoc::BPSTpair wPair;
	*npoin = 0;
	//
	if( anode <= 0 ) { //ߓ_
	} else if( (apsts = nodes.a[anode].asocT) <= 0 ) { //ߓ_PSTree
		//ߓ_PSTree(tߓ_)ꍇAߓ_ԍpairList[]zɓB
		apoin = nodes.a[anode].point;   CHKA(0, apoin, points.a.size());
		pairList->clear();
		pairList->push_back(apoin);
		*npoin = 1;
	} else {
		//PSTree::getQList()ŏ(compX())pair[]ỸXgDrTrees::pIdxList[]
		PSTreeAsoc &pst = psts.ary[apsts];
		pairList->resize(points.a.size());
//		pst.getNList(&(*pairList)[0], points.a.size(), npoin);
		pst.getNList(pairList);
		*npoin = pairList->size();
	}
	if(dbgf[8]) { //compX  check
		for( i = 1; i < *npoin; ++i ) {
			rtc = compPointL(level, (*pairList)[i-1], (*pairList)[i] ); CHKA(rtc, rtc, 0);
		}
	}
	return 0;
}
/*  ID_DrTrees::makePstPair	
***************************************************************************/
int DrTrees::makePstPair(
	int level,
	int apoin,
	PSTreeAsoc::BPSTpair *wPair)
{
	wPair->n = apoin;  //PSTree̐ߓ_ԍ([Uw)DrTrees::points.a[]ƂB NT120423
	wPair->x = points.x[level + points.a[apoin].topX];
	wPair->y = points.x[level + points.a[apoin].topX + 1];
	return 0;
}
/*  ID_DrTrees::meargePst	lc(v)rc(v) Tassoc}[W, v ǉTassoc(v) 
***************************************************************************/
int DrTrees::meargePst(  //r 0>:PST̔ԍpsts.ary[] 0:tȂ̂PSTȂ
	int level,        //i 0:
	int oyaNode)      //i eߓ_@0:ŐeȂ               node[]
{
	int rc, minAssoc, oypoin, selpoin, alist, blist, cnt, apair;
	int L_size, R_size;
	int apsts;
	PSTreeAsoc *pst;
	PSTreeAsoc::BPSTpair wPair, pPair;
//	VECTOR<int> &sortwk = *vectPool.newVect(); CHKB(0, sortwk.size(), 0);
//	sortwk.resize(points.a.size()); //NT110413add
//	int *Plist = &sortwk[0];
//	int maxP = sortwk.size();

	/* Lpair[]̓YXg */
	psts.sortwkPst.clear();
	//qm[h̓؂yȀt̃Xg
	makePairList(level, nodes.a[oyaNode].left , &pListL, &L_size);
	//Eqm[h̓؂yȀt̃Xg
	makePairList(level, nodes.a[oyaNode].right, &pListR, &R_size);
	//yA̔zpListL[],pListR[]ɋȂPSTree炸ɁAOԂB
	if( L_size <= 0 && R_size <= 0 ) { rc = 0; goto     quit; }
	//eߓ_.pointoyaPairB
	oypoin  = nodes.a[oyaNode].point;
	makePstPair(level, oypoin, &pPair);
	//VKPSTree::pstmۂB
	apsts = psts.new_pst();
	pst = &psts.ary[apsts];
	//yA̔zpListL[],pListR[]oyaPairƂłRA}[WȂAyApstɒǉB
	alist = blist = 0;
	while( alist < L_size || blist < R_size ) {
		if       ( alist >= L_size ) { minAssoc = 1;
		} else if( blist >= R_size ) { minAssoc = -1;
//		} else { minAssoc = pstCompX(level, pListL[alist], pListR[blist]);
		} else { minAssoc = compPointL(level, pListL[alist], pListR[blist]);
//			if( pListL[apoin].n == pListR[bpoin].n ) CHKA(apoin, bpoin, -971);
			if( pListL[alist] == pListR[blist] )  CHKA(alist, blist, -971);
		}
		selpoin = (minAssoc < 0) ? pListL[alist] : pListR[blist];
		if( oypoin >= 0 ) {
			if( oypoin == selpoin ) CHKA(oypoin, selpoin, -971);
//			if( pstCompX(level, oypoin, selpoin) < 0 ) {
			if( compPointL(level, oypoin, selpoin) < 0 ) {
				apair = pst->pair_add(pPair);
				psts.sortwkPst.push_back(apair);
				oypoin = -1;
			}
		}
		makePstPair(level, selpoin, &wPair);
		apair = pst->pair_add(wPair);
		psts.sortwkPst.push_back(apair);
		if       ( minAssoc < 0 ) { ++alist;
		} else if( minAssoc > 0 ) { ++blist;
		} else { CHKB(1, minAssoc, -1); ++alist; ++blist;
		}
	}
	if( oypoin >= 0 ) {
		apair = pst->pair_add(pPair);
		psts.sortwkPst.push_back(apair);
		oypoin = -1;
	}
#if 1
//int atode_henkou;
//	for( k = 1; k < pst->pairs.a.size(); ++k ) {
//		psts.sortwkPst.push_back(k); //pst->list1
//	}
//	for( k = pst->topPair; k > 0; k = - pst->pairs.a[k].emptyNext - 1 ) {
//		if( (rc = psts.sortwkPst.push_back(k)) < 0 ) goto            quit; //pst->list1
//	}
//	cnt = psts.sortwkPst.size() - 1;
//	for( k = 0; k < cnt; ++k, --cnt ) {
//		rc = psts.sortwkPst[k]; psts.sortwkPst[k] = psts.sortwkPst[cnt]; psts.sortwkPst[cnt] = rc;
//	}
	//pst.build_sorted()pstree\B
	if( (cnt = psts.sortwkPst.size()) <= 0 ) psts.sortwkPst.push_back(0); //psts.sortwkPst[0]QƏo悤Ƀ_~[ǉĂ
	if( (rc = pst->build_sorted(cnt, &psts.sortwkPst[0])) < 0 ) goto   quit;
#else
	if( (rc = pst->build()) < 0 ) goto                                    quit;
#endif
	rc = apsts;
quit:
//	vectPool.delVect(&sortwk);
	return rc;
}

/*  ID_DrTrees::create	̈؂ꊇ\B
***************************************************************************/
int DrTrees::create()
{
	int i, hi, cnt;
	//_W
//	VECTOR<int> &sortwk = *vectPool.newVect();
//	                               CHKB(0, sortwk.size(), 0);
	pListC.clear();
	for( i = 0; i < points.a.size(); ++i ) {
		if( points.a[i].usef == 0 ) continue;
		if( points.a[i].topX <= 0 ) { CHKA(1, points.a[i].topX, points.x.size()); continue;}
		pListC.push_back(i);
	}
	dim = points.dim;
	//_WP x1WŃ\[g
	if( (cnt = pListC.size()) <= 0 ) pListC.push_back(0); //pListC[0]QƏo悤Ƀ_~[ǉĂ
	xqsort(&pListC[0], cnt, *this, &DrTrees::compPoint0); //NT110705
	//̈؂\B
	mainTree = Build2DRangeTree(0, 0, cnt, &pListC[0], &hi, 1);
//	vectPool.delVect(&sortwk);
	return 0;
}
