/*
 * FILE     : pstree1.cpp
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(place holder)(balanced priority search trees)
	          l̕tT؁Al̃q[v
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
   2011/04/04 heapTypeǉB 0:傫D 1:D
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h> //http://www.jaist.ac.jp/~t-asano/dstruct/kousei.txt

#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define     E 0          /* oXx E: EB*/
#define     L -1         /* oXx L: ɌXĂB*/
#define     R 1          /* oXx R: EɌXĂB*/
#define isEmpty(p) ((p)<=Empty)

#define PSTree_Main
#include "McCreight1.h" // McCreght (Place Holderŋp)
#include "xqsort.h"

static int unbalance = 0;  //eXgpB1:oXȂ

/*	ID_PSTree::firstPair	LȑSyA̍ŏ̂PԂ
/*******************************************************************/
int PSTree::firstPair(int *inf) //>=0:ߓ_ԍ([Uw) -1:I
{
	int kol;
	*inf = root;
	for( kol = nodes.a.v[*inf].left; ; kol = nodes.a.v[kol].left ) {		CHKA(0, kol, nodes.a.size());
		if( isEmpty(nodes.a.v[kol].left) ) break; //t(PlaceHolder)܂ō~
		*inf = kol;
	}
	return (isEmpty(*inf) ) ? -1 : this->pairs.a.v[nodes.a.v[*inf].q].n;
}
/*	ID_PSTree::nextPair	LȑSyA̎̂PԂ
/*******************************************************************/
int PSTree::nextPair(int *inf) //>=0:ߓ_ԍ([Uw) -1:I
{
	int kol;

	if( nodes.a.v[*inf].right <= 0 ) {
		//Eq̂Őeǂčŏ̉Ee
		kol = *inf;									CHKA(1, kol, nodes.a.size());
		for( *inf = nodes.a.v[*inf].oya; *inf > 0; *inf = nodes.a.v[*inf].oya ) {
			if( nodes.a.v[*inf].left == kol ) break;
			kol = *inf;
		}            CHKB(0, 0, *inf); //*inf < 0 ͂肦Ȃ͂
	}
	//ɕԂ͉̂Eq̍ōq
	for( kol = nodes.a.v[*inf].right; kol > 0; kol = nodes.a.v[kol].left ) {
		if( isEmpty(nodes.a.v[kol].left) ) break; //t(PlaceHolder)܂ō~
	}
	*inf = kol;
	return (isEmpty(*inf) ) ? -1 : this->pairs.a.v[nodes.a.v[*inf].q].n;
}
/*	ID_PSTree::findBelow	m[h̉T(܂)
/*******************************************************************/
int PSTree::findBelow(  //anodeȉłłm[hԂ
	int anode )
{
	int rc = Empty;                 CHKA(0, anode, nodes.a.size());
	BPSTnode &t = nodes.a.v[anode];    CHKA(0, t.q, pairs.a.size()); CHKA(0, t.p, pairs.a.size());
	BPSTpair &q = pairs.a.v[t.q];
	BPSTpair &p = pairs.a.v[t.p];
	if( isEmpty(anode) ) goto                                    quit;
	if( isEmpty(t.p) || compHeap(pairs.a.v[t.p].y, y0) > 0 ) goto quit;
	//TBΏI
	if( ! isEmpty(t.left) && q.x >= x1 )
		if( (rc = findBelow(t.left)) != Empty ) goto             quit;
	//m[h`FbNBΏI
	if( p.x >= x1 && p.x <= x2 ) { rc = anode; goto quit;}
	//ET
	if( ! isEmpty(t.right) && q.x <= x2 )
		rc = findBelow(t.right);
quit:
	return rc;
}

/*  ID_PSTree::ReportInPSTree
***************************************************************************/
int PSTree::ReportInPSTree(int anode, int y0,
	VECTOR<int>& ans, VECTOR<int>& stack)
//́Fq[vT؂̐ߓ_n Ǝ[y0:]
//óFy[y0:]ɗLT ׂ̂Ă̓_ans[]ɒǉB
//	X^bNɃ{gnullvbV_EB
{
	int		rc = 0, n_stack, v;
	BPSTnode *vn;
	v = anode;                                             //v  anode
	n_stack  = 1; stack[0] = 0;                            //stack bottom 쐬
	while( v > 0 ) {                                       //v nullłȂ do
		vn = &nodes.a[v];
		if( vn->p > 0 ){        		CHKA(1, vn->p, pairs.a.size());      //v.p > 0 then
			if( compHeap(pairs.a.v[vn->p].y, y0) <= 0 ) {     //v.p.yq[v𖞂 then
				ans.push_back( vn->p );
				if( vn->left > 0 ) {                       //if v.left nullłȂ
					if( vn->right > 0 )                    //if v.right nullłȂ
						stack[n_stack++] = vn->right;      //v.rightvbV_EB
					v = vn->left;                          //v  v.left
					continue;
				} else if( vn->right > 0 ) {               //v.right nullłȂ
					v = vn->right;                         //v  v.right
					continue;
				}
			}
		}
		v = stack[--n_stack];                             //v  |bvAbv
	}                                                     //end while
	return rc;
}
/*  ID_PSTree::PSTreeQuery
***************************************************************************/
int PSTree::side3Query( // >=0:𓚐 <0:G[
	int x1, int x2, int y0,
	VECTOR<int>& ans, VECTOR<int>& stack)
//́Fq[vTT ƂR[x1:x2]~[y0:]
//óFR[x1:x2]~[y0:]ɗLT ׂ̂Ă̓_̃Xgans[]B
{
	int 	rc = 0, v, vsplit, aans, apair;
	BPSTnode *vn;
	ans.clear();
//	ans.push_back(0); //[0]̓_~[
	stack.resize(nodes.a.size());       //ReportInPSTree()Ŏg߁B
	v = this->root;                                //v  T.root
	//SplitNodeTB
	while( v > 0 ) {                               //while v nullłȂ do
		vn = &nodes.a[v];					CHKA(0, vn->p, pairs.a.size());
		if( vn->p > 0 ) {                              //if v.p > 0 then
			if( compHeap(pairs.a.v[vn->p].y, y0) <= 0 ) { //if v.p.yq[v𖞂 then
				//v.p񍐂ׂǂׂ(xl̂ݒׂ)
				if( x1 <= pairs.a.v[vn->p].x && pairs.a.v[vn->p].x <= x2 ) {
					if( ans.push_back( vn->p ) < 0 ) { rc = -1; goto                 quit; }
				}					    CHKA(1, vn->q, pairs.a.size());
				if( pairs.a.v[vn->q].x < x1 ) {            //if v.q.x < x1 then
					v = nodes.a[v].right;              //	v  v.right
				} else if( pairs.a.v[vn->q].x > x2 ) {     //else if v.q.x > x2 then
					v = nodes.a[v].left;               //	v  v.left
				} else break;                        //SplitNode𔭌̂Ń[vI
				continue;
			}
		}
		//A܂́Av.p.yq[v𖞂ȂȂ炻̉͌Ȃ
		v = 0;                                      //v  null
	}                                               //end while
	vsplit = v;                                     //vsplit  v
	if( vsplit == 0 ) {                             // vsplitnull then Ȃ
	} else {
		// x1ւ̌oHɉCoH̐ߓ_Ƃ̉E̕؂̃f[^
		v = nodes.a[vsplit].left;                      //v  vsplit.left
		while( v > 0 ) {                            //v nullłȂ do
			vn = &nodes.a[v];              CHKA(0, vn->p, pairs.a.size());
			if( vn->p > 0 ) {                   //if v.p > 0 then
				if( compHeap(pairs.a.v[vn->p].y, y0) <= 0 ) { //if v.p.yq[v𖞂 then
					//v.p񍐂ׂǂׂ(x1l̂ݒׂ)
					if( x1 <= pairs.a.v[vn->p].x ) {
						if( ans.push_back( vn->p ) < 0 ) { rc = -1; goto             quit; }
					}                   CHKA(1, vn->q, pairs.a.size());
					if( pairs.a.v[vn->q].x >= x1 ) {           //if v.q.x >= x1 then
						ReportInPSTree(nodes.a[v].right, y0, ans, stack);
						v = nodes.a[v].left;              //v  v.left
					} else {
						v = nodes.a[v].right;             //v  v.right
					}
					continue;
				}
			}
			//A܂́Av.p.yq[v𖞂ȂȂ炻̐ߓ_͌Ȃ
			v = 0;                                 //v  null
		}                                              //end while
		// x2 ւ̌oHɉC̍̕؂̃f[^
		v = nodes.a[vsplit].right;                        //v  vsplit.right
		while( v > 0 ) {                               //v nullłȂ do
			vn = &nodes.a[v];              CHKA(0, vn->p, pairs.a.size());
			if( vn->p > 0 ) {                              //v.p > 0 then
				if( compHeap(pairs.a.v[vn->p].y, y0) <= 0 ) { // v.p.yq[v𖞂 then
					//v.p񍐂ׂǂׂ(x2l̂ݒׂ)
					if( pairs.a.v[vn->p].x <= x2 ) {
						if( ans.push_back( vn->p ) < 0 ) { rc = -1; goto             quit; }
					}					CHKA(1, vn->q, pairs.a.size());
					if( pairs.a.v[vn->q].x <= x2 ) {           //if v.q.x <= x2 then
						ReportInPSTree(nodes.a[v].left, y0, ans, stack);
						v = nodes.a[v].right;             //v  v.right
					} else {
						v =  nodes.a[v].left;              // v  v.left
					}
					continue;
				}
			}
			//A܂́Av.p.yq[v𖞂ȂȂ炻̐ߓ_͌Ȃ
			v = 0;                                  //v  null
		}                                              //end while
	}
	for( aans = 0; aans < ans.size(); ++aans ) {
		apair = ans[aans];
		ans[aans] = pairs.a.v[apair].n;
	}
	rc = ans.size();
quit:
	return rc;
}
/*	ID_PSTree::firstAns	Rx1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::firstAns(  //ߓ_ԍ([Uw)B-1:Yߓ_
	int *inf,                    //o 0:Yߓ_
	int px1, int px2, int py0)   //i T x1xx2yy0łm[h
{
#if 0
	int rc, qq;
	if( (rc = side3Query(px1, px2, py0, ans, stack)) < 0 ) { rc = -99; goto    quit; }
	*inf = 0;
	qq = (0 < ans.size()) ? ans[0] : 0;                    CHKA(0, qq, pairs.a.size());
	rc = (qq > 0) ? pairs.a.v[qq].n : -1;
quit:
	return rc;
#else
	int 	anode = root, qq;

	x1 = px1; x2 = px2; y0 = py0;
	*inf = findBelow(anode);         //NT110803chg last_node ==> *inf
	qq = nodes.a.v[*inf].p;             CHKA(0, qq, pairs.a.size());
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#endif
}
/*	ID_PSTree::nextAns	Rx1xx2yy0ł鎟̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::nextAns(   //ߓ_ԍ([Uw)B-1:Yߓ_
	int *inf)                    //io 0:Yߓ_
//	int px1, int px2, int py0)   //T x1xx2yy0łm[h NT120423add
{
#if 0
	int		qq; //profilełPR
	++(*inf);
	qq = (*inf < ans.size()) ? ans[*inf] : 0;
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#else
	int 	anode = *inf, rt, qq, oy;
	*inf = Empty;
	//Em[hrootƂčōm[h
	while( ! isEmpty(anode) && isEmpty(*inf) ) {
		//ET
		if( (*inf = findBelow( nodes.a.v[anode].right)) != Empty ) break;
		//ŏ̉E̐eBΊ
		oy = -1;
		for( rt = anode; ! isEmpty(rt); rt = oy ) {
			oy = nodes.a.v[rt].oya;
			if( rt == nodes.a.v[oy].right ) continue;
			break;
		}  CHKB(0, oy, oy);
		if( (anode = oy) == Empty ) break;
		qq = nodes.a.v[anode].p;               CHKA(1, qq, pairs.a.size()); //CHKB(x1, x1, pairs.a.v[qq].x);
		//m[h`FbN
		if( pairs.a.v[qq].x >= x1 && pairs.a.v[qq].x <= x2 && compHeap(pairs.a.v[qq].y, y0) <= 0 ) {
			*inf = anode;
			break;
		}
	}
	qq = nodes.a.v[*inf].p;
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#endif
}
/*	ID_PSTree::first	x1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::first(  ////p~Ȃ
	int px1, int px2, int py0)   //T x1xx2yy0łm[h
{
#if 0
	int 	anode = root, qq;

	x1 = px1; x2 = px2; y0 = py0;
	last_node = findBelow(anode);
	qq = nodes.a.v[last_node].p;             CHKA(0, qq, pairs.a.size());
	return pairs.a.v[qq].n;
#else
	int rc;
	NextInf ni(root, 0);
	if( root > 0 ) {
		x1 = px1; x2 = px2; y0 = py0;
		nextInf.clear();
		nextInf.push_back(NextInf(0, 0));    //X^bN{g쐬
		nextInf.push_back(NextInf(root, 0)); //TJnm[h
		rc = next();
	} else rc = -1;
	return rc;
#endif
}
/*	ID_PSTree::next	x1xx2yy0ł鎟̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::next()  ////p~Ȃ
{
#if 0
	int 	anode = last_node, rt, qq, oy;

	last_node = Empty;
	//Em[hrootƂčōm[h
	while( ! isEmpty(anode) && isEmpty(last_node) ) {
		//ET
		if( (last_node = findBelow( nodes.a.v[anode].right)) != Empty ) break;
		//ŏ̉E̐eBΊ
		oy = -1;
		for( rt = anode; ! isEmpty(rt); rt = oy ) {
			oy = nodes.a.v[rt].oya;
			if( rt == nodes.a.v[oy].right ) continue;
			break;
		}  CHKB(0, oy, oy);
		if( (anode = oy) == Empty ) break;
		qq = nodes.a.v[anode].p;               CHKA(1, qq, pairs.a.size()); //CHKB(x1, x1, pairs.a.v[qq].x);
		//m[h`FbN
		if( pairs.a.v[qq].x >= x1 && pairs.a.v[qq].x <= x2 && compHeap(pairs.a.v[qq].y, y0) <= 0 ) {
			last_node = anode;
			break;
		}
	}
	qq = nodes.a.v[last_node].p;
	return pairs.a.v[qq].n;
#else
	int rc, pyOk;
	BPSTnode *t;
	NextInf *topOfStack = &nextInf.v[nextInf.size() - 1];
	while( topOfStack->node > 0 ) {
		t = &nodes.a.v[topOfStack->node];
		pyOk = (! isEmpty(t->p) && compHeap(pairs.a.v[t->p].y, y0) <= 0); //Land p.ynj
		switch( topOfStack->stat ) {
		case 0: //0:} Land p.ynjand x1q.x and leftL
			if( pyOk && t->left > 0 && x1 <= pairs.a.v[t->q].x && ! isEmpty(nodes.a.v[t->left].p) ) {
				topOfStack->stat = 1;
				do {
					nextInf.push_back(NextInf(t->left, 1));
					t = &nodes.a.v[t->left];
					pyOk = (! isEmpty(t->p) && compHeap(pairs.a.v[t->p].y, y0) <= 0); //Land p.ynj
				} while( pyOk && t->left > 0 && x1 <= pairs.a.v[t->q].x && ! isEmpty(nodes.a.v[t->left].p) );
				topOfStack = &nextInf.v[nextInf.size() - 1];
			}
		case 1: //1: Land p.ynjand x1p.xx2
			if( pyOk && x1 <= pairs.a.v[t->p].x && pairs.a.v[t->p].x <= x2 ) {
				topOfStack->stat = 3;
				rc = pairs.a.v[t->p].n;
				goto                                                    quit;
			}
		case 3: //3:E} Land p.ynjand q.xx2 and rightL
			if( pyOk && t->right > 0 && pairs.a.v[t->q].x <= x2 && ! isEmpty(nodes.a.v[t->right].p) ) {
				*topOfStack = NextInf(t->right, 0);
			} else {
				nextInf.pop_back();
				topOfStack -= 1;
			}
		}
	}
	rc = -1;
quit:
	return rc;
#endif
}

/*  ID_PSTree::disposeP	t.ppushāAq[vm[hɂ
***************************************************************************/
int PSTree::disposeP( int anode )
{
	int rc;
	BPSTnode	*t;                               CHKA(1, anode, nodes.a.size());
	t = &nodes.a.v[anode];
	if( ! isEmpty(t->p) ) {                       CHKA(1, t->q, pairs.a.size());
		rc = compX(&pairs.a.v[t->p], &pairs.a.v[t->q]);
		if( rc == 0 )                             CHKB(t->p, t->q, t->p);
		if( rc <= 0 ) { CHKA(1, t->left, nodes.a.size()); //t.p̎qpush
			disposeP( t->left );                  //  t.left.ppushāAɂ
			nodes.a.v[t->left].p = t->p;             //  t.left.pt.p
		} else {                                  CHKA(1, t->right, nodes.a.size());
			disposeP( t->right );
			nodes.a.v[t->right].p = t->p;
		}
		t->p = Empty;
	}
	return 0;
}
/*  ID_PSTree::extractP	t.ppopāAq[v̋𖄂߂B óFt.p t.validP t.left.duplQ t.right.duplQ
***************************************************************************/
int PSTree::extractP( int anode )
{
	int		lp, rp, lrf;                    CHKA(0, anode, nodes.a.size());
	BPSTnode	&t = nodes.a.v[anode];

	if( ! isEmpty(anode) ) {
		lp = nodes.a.v[t.left].p;              CHKA(0, lp, pairs.a.size());
		rp = nodes.a.v[t.right].p;             CHKA(0, rp, pairs.a.size());
		if     ( isEmpty(lp) ) lrf = R;
		else if( isEmpty(rp) ) lrf = L;
		else lrf = compHeap( pairs.a.v[lp].y, pairs.a.v[rp].y);
		if( lrf < 0 ) {
			t.p = lp;
			extractP( t.left );
		} else {
			t.p = rp;
			extractP( t.right );
		}
	}
	return 0;
}
/*  ID_PSTree::rotateRight
***************************************************************************/
int PSTree::rotateRight(
	int *anode,         // io
	int *phi )          //  o ]*anode̍
{
	int		c, e, q, r, s, he, hc, hq, hr, hs;
	e = *anode;                              CHKA(1, e, nodes.a.size());
	disposeP( e );
	c = nodes.a.v[e].left;                      CHKA(1, c, nodes.a.size());
	s = nodes.a.v[e].right;                     CHKA(1, s, nodes.a.size());
	q = nodes.a.v[c].left;                      CHKA(1, q, nodes.a.size());
	r = nodes.a.v[c].right;                     CHKA(1, r, nodes.a.size());
	disposeP( c );
	nodes.a.v[c].oya   = nodes.a.v[*anode].oya;
	*anode = c;
	if( ! isEmpty(r) ) nodes.a.v[r].oya   = e;
	else
		r = r;  //ɂ͗Ȃ
	nodes.a.v[e].left  = r;
	extractP( e );
	nodes.a.v[e].oya   = c;
	nodes.a.v[c].right = e;
	extractP( c );
	hq = nodes.a.v[q].hight;
	hr = nodes.a.v[r].hight;
	hs = nodes.a.v[s].hight;
	he = 1 + ((hr > hs) ? hr : hs);
	hc = 1 + ((hq > he) ? hq : he);
	nodes.a.v[e].hight = he;
	nodes.a.v[c].hight = hc;
	//adjustBalanceForRotateRight(c)
	*phi = hc;
	return 0;
}
/*  ID_PSTree::rotateLeft
***************************************************************************/
int PSTree::rotateLeft(
	int *anode,         // io
	int *phi )          //  o ]*anode̍
{
	int		c, e, q, r, s, he, hc, hq, hr, hs;
	e = *anode;                            CHKA(1, e, nodes.a.size());
	disposeP( e );
	c = nodes.a.v[e].right;                   CHKA(1, c, nodes.a.size());
	s = nodes.a.v[e].left ;                   CHKA(1, s, nodes.a.size());
	q = nodes.a.v[c].right;                   CHKA(1, q, nodes.a.size());
	r = nodes.a.v[c].left ;                   CHKA(1, r, nodes.a.size());
	disposeP( c );
	nodes.a.v[c].oya   = nodes.a.v[*anode].oya;
	*anode = c;
	if( ! isEmpty(r) ) nodes.a.v[r].oya   = e;
	else
		r = r;  //ɂ͗Ȃ  NT111221 
	nodes.a.v[e].right = r;
	extractP( e );
	nodes.a.v[c].left  = e;
	nodes.a.v[e].oya   = c;
	extractP( c );
	hq = nodes.a.v[q].hight;
	hr = nodes.a.v[r].hight;
	hs = nodes.a.v[s].hight;
	he = 1 + ((hr > hs) ? hr : hs);
	hc = 1 + ((hq > he) ? hq : he);
	nodes.a.v[e].hight = he;
	nodes.a.v[c].hight = hc;
	//adjustBalanceForRotateRight(c)
	*phi = hc;
	return 0;
}
/*  ID_PSTree::adjustBalance	k/q]ŃoX߂
***************************************************************************/
int PSTree::adjustBalance(
	int *anode,            // io
	int *phi)              //  o
{
	BPSTnode	*t;
	int bc1, bc2, hL, hR;
	if( ! isEmpty(*anode) ) {           CHKA(1, *anode, nodes.a.size());
		bc1 = judgeBalance(*anode);
		t = &nodes.a.v[*anode];
		if( unbalance != 0 || bc1 > -2 && bc1 < 2) {
			hL = nodes.a.v[t->left ].hight;
			hR = nodes.a.v[t->right].hight;
			*phi = 1 + ((hL > hR) ? hL : hR);
			nodes.a.v[*anode].hight = *phi;
		} else if( bc1 <= -2 ) {       //ɌX
			if( (bc2 = judgeBalance(t->left)) >= 1 ) {  //EɌXĂ
				rotateLeft(&t->left, &hL );
			} else CHKB(-1, bc2, 0);
			rotateRight(anode, phi );
			//bc1 = judgeBalance(*anode); CHKB(-1, bc1, 1);
		} else if( bc1 >= 2 ) {                          //EɌX
			if( (bc2 = judgeBalance(t->right)) <= -1 ) { //ɌXĂ
				rotateRight(&t->right, &hR );
			} else CHKB(0, bc2, 1);
			rotateLeft(anode, phi );  //*s(=anode)̒lς
			//bc1 = judgeBalance(*anode); CHKB(-1, bc1, 1);
		} else CHKA(0, 0, -1);
	}
	return 0;
}
/*  ID_PSTree::insert	oyam[h̍/Eɒǉ
***************************************************************************/
int PSTree::insert( //oyam[h̎qm[hԍԂB0:[hő݂Ȃ -1:G[
				    //qm[h͍̍XVݒ肷
	int oya,        //i  ŏʂ͐e(Empty)Ōďo node[]or-1
	int lrflg,      //i  -1: 1:E 0:oyaEmpty
	int np,         //i  pair[]
	bool useAsP,    //i  T:npq[vɓꂽ(rootm[hł.T.ŌĂ) F:npq[v̑Rׂꏊɓꂽ
	int *phi,       // o ǉ̎qm[h̍
	int findmode)   //i  [h 0:ǉ 1:ǉ
{
	BPSTnode	*t;
	int		anode, bnode, cnode, rc, hL, hR, *s, nextoya, npy;
	                                         CHKA(0, oya, nodes.a.size());
	if( isEmpty(oya) ) { anode = root; CHKB(0, lrflg, 0);}  //anode:oyam[h̎qB}m[h
	else if( lrflg < 0 ) anode = nodes.a.v[oya].left;
	else if( lrflg > 0 ) anode = nodes.a.v[oya].right;
	                                         CHKA(0, anode, nodes.a.size());
	if( isEmpty(anode) ) {
		if( findmode ) {  //݂ȂBO(Empty)Ԃ
		} else {
			BPSTnode	wkNode1, wkNode2;
			wkNode1.oya = oya;
			wkNode1.q   = np;
			*phi = 1;
			wkNode1.hight = *phi;
			anode = node_add(wkNode1);
			if( isEmpty(oya) ) {
				root = anode ;
			} else {
				wkNode2 = nodes.a.v[oya];
				wkNode2.oya = oya;
				wkNode2.p   = Empty;
				bnode = node_add(wkNode2);
				if( lrflg < 0 ) {
					nodes.a.v[oya].left   = anode ;
					nodes.a.v[oya].right  = bnode ;
					nodes.a.v[oya].q  = np ;
				} else if( lrflg > 0 ) {
					nodes.a.v[oya].right = anode ;
					nodes.a.v[oya].left  = bnode ;
				}
			}
			//q[v̓VT
			cnode = anode;
			npy   = pairs.a.v[np].y;
			for( nextoya = oya; ! isEmpty(nextoya); nextoya = t->oya ) {
				t = &nodes.a.v[nextoya];
				if( ! isEmpty(t->p) && compHeap(pairs.a.v[t->p].y, npy) <= 0 ) break;
				cnode = nextoya;
			}
			disposeP(cnode);
			nodes.a.v[cnode].p = np;
			//t->balance = leafBalance;
		}
	} else {
		t = &nodes.a.v[anode];
		int lrf = compX(&pairs.a.v[np], &pairs.a.v[t->q]);
		if( lrf < 0 ) {  //T؂ւ̑}͖[܂łǂ
			hR = nodes.a.v[t->right].hight;
			if( (rc = insert(anode, -1, np, useAsP, &hL, findmode)) < 0 ) goto quit;  // qɑ}
		} else if( lrf > 0 ) {
			hL = nodes.a.v[t->left].hight;
			if( (rc = insert(anode,  1, np, useAsP, &hR, findmode)) < 0 ) goto quit;  // Eqɑ}
		} else if( ! findmode )                 CHKA(1, lrf, -1);
		if( lrf == 0 ) {  //ȂǉA̒lԂB
		} else if( ! findmode ) {
			//insert͎͂gȂBrealloc()Ȃ̂ŁB
			t = &nodes.a.v[anode];
			if( isEmpty(oya) ) { s = &root;  CHKB(0, lrflg, 0);}  //anode:oyam[h̎qB}m[h
			else if( lrflg < 0 ) s = &nodes.a.v[oya].left;
			else if( lrflg > 0 ) s = &nodes.a.v[oya].right;
			//adjustBalanceForInsert(t);
#if 0 //ăoXȂł̃eXgp
			nodes.a.v[anode].hight = 1 + ((hL > hR) ? hL : hR);
			*phi = nodes.a.v[anode].hight;
#else
			adjustBalance( s, phi );
#endif
		}
	}
	rc = anode;
quit:
	return rc;
}
/*+++++++++++++++++++++++++++++++++++ delete ==> +++++++++++++++++++++++++++++++++++++++*/
/*  ID_PSTree::isLeaf	E̎qm[hȂA[̗tǂ𒲂ׂ
***************************************************************************/
int PSTree::isLeaf( int anode )
{
	                                         CHKA(0, anode, nodes.a.size());
	int rc = isEmpty(nodes.a.v[anode].left);
	if( rc ) CHKB(Empty, nodes.a.v[anode].right, Empty);
	return rc;
}
/*  ID_PSTree::deletion	m[h폜
***************************************************************************/
int PSTree::deletion( // 0:o^ 1:폜
	int *anode,       // io ŏʂ&rootŌďoBEmpty̏ꍇ
	BPSTpair &op,     // i  폜Ώۂ̃yA
	int *phi,         // o  폜*anode̍
	int qnode)        // i  폜m[h(.q=op)
{
	int		d, delf = 0, hL, hR, oya, oyaoya, oL, oR; CHKA(0, *anode, nodes.a.size());
	BPSTnode	&t = nodes.a.v[*anode];
	                                       CHKA(0, t.q, pairs.a.size());
	if( ! isEmpty(*anode) ) {   //CHKA(1, qnode, nodes.a.size());
		if( isLeaf(*anode) ) {
			if( ! (pairs.a.v[t.q] == op) ) {CHKB(0, qnode, 0); goto quit;} //݂Ȃ
			oya = nodes.a.v[*anode].oya;     //yAP̏ꍇ̂݁Arootleaf NT110604chg
			if( n_pair == 1 )             {CHKB(0, oya, 0);}
			else                          {CHKA(1, oya, nodes.a.size());}
			if( oya > 0 ) {
				oyaoya = nodes.a.v[oya].oya;      CHKA(0, oyaoya, nodes.a.size());  //<==CHKA(1 NT110604chg
				oL = nodes.a.v[oya].left;         CHKA(1, oL, nodes.a.size());
				oR = nodes.a.v[oya].right;        CHKA(1, oR, nodes.a.size());
			} else oyaoya = oL = oR = 0;       //NT110604add
			*phi = 0;
			delf = 2;
			//disposeP( *anode );
			pair_del( t.q );
			d = *anode;
			node_del( d );
			if( isEmpty(oya) ) {
				*anode = Empty;
				delf = 1;
			} else {
				if     ( oL == *anode ) *phi = nodes.a.v[oR].hight;
				else if( oR == *anode ) *phi = nodes.a.v[oL].hight;
				else                     CHKA(oL, oR, -1);
				if( isEmpty(qnode) ) {   CHKB(*anode, oR, *anode);
					disposeP( oya );
					nodes.a.v[oL].oya = oyaoya;
					if( isEmpty(oyaoya) )
						root = oL;
					else if( nodes.a.v[oyaoya].right == oya )
						nodes.a.v[oyaoya].right = oL;
					else
						nodes.a.v[oyaoya].left = oL;
					node_del( oya );
				} else if( oya == qnode ) {     CHKB(*anode, oL, *anode);
					disposeP( oya );
					nodes.a.v[oR].oya = oyaoya;
					if( isEmpty(oyaoya) )
						root = oR;
					else if( nodes.a.v[oyaoya].right == oya )
						nodes.a.v[oyaoya].right = oR;
					else
						nodes.a.v[oyaoya].left = oR;
					node_del( oya );
				} else {
					disposeP( oya );
					nodes.a.v[oL].oya = oyaoya;
					if( isEmpty(oyaoya) )
						root = oL;
					else if( nodes.a.v[oyaoya].right == oya )
						nodes.a.v[oyaoya].right = oL;
					else
						nodes.a.v[oyaoya].left = oL;
#if 1 //m[hoyâĂꍇA
					nodes.a.v[qnode].q = nodes.a.v[oya].q;
					node_del( oya );
#else //m[hqnodêĂꍇA
#endif
				}
			}
		} else {
			if( pairs.a.v[t.p] == op )
				extractP( *anode );
			if( pairs.a.v[t.q] == op ) {
				qnode = *anode;
				//disposeP( *anode );
			}
			if( compX(&op, &pairs.a.v[t.q]) <= 0 ) { //͍ɐi
				hR = nodes.a.v[t.right].hight;
				delf = deletion( &t.left , op, &hL, qnode );
			} else {
				hL = nodes.a.v[t.left ].hight;
				delf = deletion( &t.right, op, &hR, qnode );
			}
			oL = nodes.a.v[*anode].left;
			oR = nodes.a.v[*anode].right;
			if( delf == 2 ) {
				delf = 1;
				*phi = 0;
			} else if( isEmpty(oL) ) {        CHKB(Empty, oR, Empty);
				*phi = 1;
			} else {
				hL = nodes.a.v[oL].hight;
				hR = nodes.a.v[oR].hight;
				*phi = 1 + ((hL > hR) ? hL : hR);
			}
			nodes.a.v[*anode].hight = *phi;
			adjustBalance( anode, phi );
		}
		//adjustBalanceForDelete(t);
	}
quit:
	return delf;
}
/*+++++++++++++++++++++++++++++++++++ delete <= +++++++++++++++++++++++++++++++++++++++*/
/*  ID_PSTree::build_sub	\[gς݂pairXgċAIPSTreeBNlogN
***************************************************************************/
int PSTree::build_sub(int *list, int s, int e)  //0:list[s,e] >0:؂̍node[]Y <0:G[
{
	int rc = 0, i, a;
	BPSTnode f;
	BPSTnode r;

	if( s > e ) goto                          quit;   // 0 ԂďIB
	if( s == e ) {    // tm[hAԂďIB
		f.p = list[s]; f.q = list[s]; f.hight = 1;
		rc = node_add( f );
		goto                                  quit;
	}
	i = ( s + e ) / 2; a = list[i];  //:pair[]YBpair[]͍q؂̂ő̃m[hƂȂ
	/* ԃm[hpair[] */
	r.q = a; r.p = 0;		//.A.͋
	r.left  = build_sub(list, s, i);
	r.right = build_sub(list, i+1, e);
	r.hight = ( (nodes.a.v[r.left].hight)>(nodes.a.v[r.right].hight) ) ? (nodes.a.v[r.left].hight):(nodes.a.v[r.right].hight);  //.left,rightvZ
	r.hight++;
	rc = node_add( r );
	if( ! isEmpty(r.left ) ) nodes.a.v[r.left].oya = rc;
	if( ! isEmpty(r.right) ) nodes.a.v[r.right].oya = rc;
	//q[v.̋𖄂߂B
	extractP( rc ); //ōň̏ꍇlogN̎Ԃ
quit:
	return rc;
}
/*  ID_PSTree::build_sorted
***************************************************************************/
int PSTree::build_sorted( //0: <0:G[ >0:f[^G[
	int nList,   //i
	int *list)   //i pair[]ỸXg
{
	int rc, k, apair, bpair;
	/*	pair[]thisclear()BheapType,pair[],n_pair̓NAȂ */
	clear1();
	//`FbN̂
	if(dbgf[8]) {
		for( k = 1; k < nList; ++k ) {
			apair = list[k-1];
			bpair = list[k];
			rc = compX( &pairs.a.v[apair], &pairs.a.v[bpair]); CHKB(rc, -1, -1);
		}
	}
	if(dbgf[9]>1) {
		Dprintf("nList(%d)\n", nList);
		Dprintf("no     n     x     y\n");
		for( k = 0; k < nList; ++k )
			Dprintf("%2d%6d%6d%6d\n",list[k], this->pairs.a.v[list[k]].n, this->pairs.a.v[list[k]].x, this->pairs.a.v[list[k]].y );
	}
	root = build_sub(list, 0, nList - 1);
	if( nList > 0 ) {CHKA(1, root, nodes.a.size());} else {CHKB(0, root, 0)}
													//CHKB(nodes.a.size()-1, n_node, nodes.a.size()-1);
	//oya(root)nil
	nodes.a.v[root].oya = 0;
	rc = 0;
	if(dbgf[8]) check0();
	if(dbgf[9]) dump_node(-1, -1);
//quit:
	return rc;
}
/*  ID_PSTree::build
***************************************************************************/
int PSTree::build( //0: <0:G[ >0:f[^G[
	VECTOR<int>& pList)
{
	int rc = 0, k, cnt;

//	/* Lpair[]̓YXg */
//	pList.clear();
//int atode_henkou;
//	for( k = 1; k < this->pairs.a.size(); ++k ) {
//		if( pairs.a.v[k].emptyNext >= 0 ) continue;
//		if( (rc = pList.push_back(k)) < 0 ) goto                     quit;
//	}
//	for( k = topPair; k > 0; k = - pairs.a[k].emptyNext - 1 ) {
//		if( (rc = pList.push_back(k)) < 0 ) goto                     quit;
//	}
	/* WŃ\[g */
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	xqsort(&pList[0], cnt, *this, &PSTree::compIdx);
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::getQList	̏pair[]ỸXgL1Bclear()͌Ăԑ
***************************************************************************/
int PSTree::getQList(sscvect<int> *L1, int anode)  //rc=0:\[gsv >0:Kv <0:s
{
	int rc = 0;
	/*	̏pair[]ỸXgL1Bclear()͌Ăԑ */
	if( anode <= 0 ) {                            //NT110823add
	} else if( nodes.a.v[anode].left == 0 && nodes.a.v[anode].right == 0 ){ //anodet node[].qL1->push()
		if( (rc = L1->push_back(nodes.a.v[anode].q)) < 0 ) goto                     quit;
	} else {
		if( (rc = getQList(L1, nodes.a.v[anode].left)) < 0 ) goto                     quit;
		if( (rc = getQList(L1, nodes.a.v[anode].right)) < 0 ) goto                    quit;
	}
	if(dbgf[8]) {
		int rtc, i;
		//compX  check
		for( rc = 0,i = 1; i < L1->size(); ++i ) {
			rtc = compX( &pairs.a.v[(*L1)[i-1]], &pairs.a.v[L1->v[i]] ); CHKA(rtc, rtc, 0);
			if( rtc > 0 ) ++rc;
		}
	}
	rc = 0;
quit:
	return rc;
}
/*  ID_PSTree::getNList	̏pair[].ñXgpIdxList[]B
***************************************************************************/
int PSTree::getNList(
//	int *pIdxList,    //o pair[].ñXg
//	int x_pIdxL,      //i
//	int *n_pIdxL)     //o
	VECTOR<int> *pIdxList) //o
{
	int i, apair;
	pIdxList->clear();
	this->getQList(pIdxList, root);
	for( i = 0; i < pIdxList->size(); ++i ) {
		apair = (*pIdxList)[i];
		(*pIdxList)[i] = this->pairs.a.v[apair].n;
	}
	return 0;
}

/*  ID_PSTree::intersect	Q̂ors(T1,T2)̋ʏWpairP̂orsB
***************************************************************************/
int PSTree::intersect(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T1, PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;

	this->clear();
	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair̋ʕthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 && k < size2 ) {
		rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if       ( rc < 0 ) { ++i;
		} else if( rc > 0 ) { ++k;
		} else {
//			if( (apair = rc = this->pair_add(T1.pairs.a.v[t1List[i]])) < 0 ) goto quit;
			BPSTpair wkPair = T1.pairs.a.v[t1List[i]];
			if( (apair = rc = this->pair_add(wkPair)) < 0 ) goto quit;
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i; ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::plus	ors(this,T2)̘aWpairors(this)B
***************************************************************************/
int PSTree::plus(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;
	PSTree &T1 = *this;

	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair}[WȂthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 || k < size2 ) {
		if     ( i >= size1 ) rc = 1;
		else if( k >= size2 ) rc = -1;
		else rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if( rc < 0 ) {
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;
		} else if( rc > 0 ) {
//			if( (apair = rc = this->pair_add(T2.pairs.a.v[t2List[k]])) < 0 ) goto quit;
			BPSTpair wkPair = T2.pairs.a.v[t2List[k]];
			if( (apair = rc = this->pair_add(wkPair)) < 0 ) goto quit;
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++k;
		} else {     //CHKA(0,0,-571);  //敪؂̉]ł͗L蓾Ȃ̂CHKG[ <==rb_delete()Ăł
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;  ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::minus	ors(this,T2)̍Wpairors(this)B
***************************************************************************/
int PSTree::minus(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;
	PSTree &T1 = *this;

	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair}[WȂthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 ) {
		if( k >= size2 ) rc = -1;
		else rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if( rc < 0 ) {
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;
		} else if( rc > 0 ) {           CHKA(0,0,-571);  //敪؂̉]ł͗L蓾Ȃ̂CHKG[
			++k;
		} else {   //`|aZł͂`폜
			apair = t1List[i];
			pair_del( apair );
			++i;  ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::dump_node
***************************************************************************/
void PSTree::dump_node(int s, int e)
{
	if( s < 0 ) s = 0;
	if( e < 0 ) e = nodes.a.size() - 1;
	Dprintf("root = %d topEmpty = %d n_node = %d n_pair = %d\n", root, nodes.getTopEmpty(), n_node, n_pair );
	for( ; s <= e; ++s ) {
		BPSTnode &t = nodes.a.v[s];
		BPSTpair &p = pairs.a.v[t.p];
		BPSTpair &q = pairs.a.v[t.q];
		if( t.oya == -2 ) continue;
		Dprintf("nodes.a.v[%2d] vP(%2d) p[%2d](%2d %3d %3d) q[%2d](%2d %3d %3d) t.p(%2d) t.q(%2d) oy(%2d) L(%2d) R(%2d) h(%2d)\n"
			, s, t.validP, t.p, p.n, p.x, p.y, t.q, q.n, q.x, q.y
			, t.p, t.q
			, t.oya, t.left, t.right, t.hight );
	} fflush(stdout);
}
/*  ID_PSTree::check1	Nƃq[vlATl`FbN
***************************************************************************/
int PSTree::check1(  //߂l = m[h
	int oya,         //e
	int v,           // node[]
	BPSTpair &low,   //[A)
	BPSTpair &upp)
{
	int left, right, rc, nsu, hL, hR, hi, op;
	BPSTnode	*t = &nodes.a.v[v];

	nsu = hL = hR = 0;
	rc = compX(&low, &upp);     CHKB(rc, rc, 0); //CHKB(-1, rc, -1);
	if( isEmpty(v) ) return 0;
	BPSTpair &qpair = pairs.a.v[t->q];            //Tl`FbN
	rc = compX(&low, &qpair);     CHKB(rc, rc, -1);   //lowv.q.xupp
	rc = compX(&qpair, &upp);     CHKB(rc, rc, 0);
	nsu = 1;                   //m[h
	//heap condition
	op = nodes.a.v[oya].p;
	if( isEmpty(oya) ) {       //oya̓`FbNȂ
	} else if( isEmpty(op) ) { CHKB(Empty, t->p, Empty);  //oya.p=Ȃqv.p=
	} else if( isEmpty(t->p) ) {
	} else {
		rc = compHeap( pairs.a.v[op].y , pairs.a.v[t->p].y  ); CHKB(rc, rc, 0); //:D :ED
	}
	//leaf͍EqȂBԃm[h͍Eq
	if( isEmpty(t->left) ) {                   CHKB(Empty, t->right, Empty); }
	else {                                     CHKA(1, t->right, nodes.a.size()); }
	//qƍ̃N`FbN
	left = t->left;
	if( ! isEmpty(left) ) {                    CHKA(1, left, nodes.a.size());
		hL = nodes.a.v[left].hight;               CHKB(v, nodes.a.v[left].oya, v);
	}
	//Eqƍ̃N`FbN
	right = t->right;
	if( ! isEmpty(right) ) {                   CHKA(1, right, nodes.a.size());
		hR = nodes.a.v[right].hight;              CHKB(v, nodes.a.v[right].oya, v);
	}
	//oX̃`FbN
	if( unbalance == 0 ) { hi = judgeBalance(v);  CHKB(-1, hi, 1); }
	if( isLeaf(v) ) {                          CHKB(1, t->hight, 1);
	} else {
		hi = 1 + ((hL > hR) ? hL : hR);        CHKB(hi, t->hight, hi); //`FbN
	}
	nsu += check1(v,  left , low, qpair);
	nsu += check1(v,  right, qpair, upp);
	return nsu;
}
/*  ID_PSTree::check0
***************************************************************************/
void PSTree::check0()
{
	static VECTOR<int> vintwk;
	int		rc, num_node;
	BPSTnode	&t = nodes.a.v[0];
	BPSTpair low(INT_MIN, INT_MIN, 0), upp(INT_MAX, INT_MAX, 0);
	CHKB(0, t.oya, 0); CHKB(0, t.left, 0); CHKB(0, t.right, 0); CHKB(0, t.p, 0); CHKB(0, t.q, 0);
	CHKB(0, t.hight, 0);
	if( root == 0 || n_pair == 0 || n_node == 0 ) { CHKB(0, root, 0);
		CHKB(0, n_pair, 0);
		CHKB(0, n_node, 0);
	}
	vintwk.clear();
	rc = getQList(&vintwk, root);       CHKB(n_pair, vintwk.size(), n_pair);
	num_node = (n_pair>0) ? 2 * n_pair - 1 : 0;   CHKB(n_node, num_node, n_node);
	rc = check1(0, root, low, upp);     CHKB(rc, n_node, rc);
}
