/*
 * FILE     : pstree_memo.h
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(balanced priority search trees)
 * AUTHER   : N.Tsuchiya  2007.11.25
 */

/*
oTF	http://www.cs.brown.edu/courses/cs252/misc/resources/lectures/pdf/notes18.pdf
	uPriority Search Trees - Part IIv Prof. Roberto Tamassia Sem. II, 1993{1994
	Lecture 10 Date: May 22, 1994 Scribe: Michael Shapiro
	E.M.McCreight. Priority search trees. SIAM Journal on Computing, 14(2):257.276, May 1985.

==========================================================================
q[vT(balanced priority search trees)
==========================================================================
Tv
	wWl̕tQT؁AxWl̃q[v

--------------------------------------------------------------------------
@\
Q̓_oȉWo~āA㕔JĂ钷`[x1:x2]~[y1:]̓ɂ_oi߂B

ւ̉p
P̐ri[xi,yi]̏Wr~āA[,]ƌri߂B
́A(-xiand yi)ł邩A[-:]~[:]̓ɂri߂B

--------------------------------------------------------------------------
\
                                   \z            T              ǉ            폜
q[vT             m             mlogm        logm{j           logm           logm

--------------------------------------------------------------------------
q[vT؂̎
^CvPiMcCreightŁjF_̐mƖ؂̐ߓ_Beߓ_P̓_ɑΉB
^CvQiv[Xz_ŁjFm̓_\[gĉɕׁiv[Xz_jȀɂm|P
	ߓ_ȂTp̖؂\Bߓ_͂Qm|PƂȂB

=========================================McCreight=================================================

em[h́AyA(x,y)Ƃ(x,y)̂Q̃yAB͋(validP=F)̂ƂB
m[hێyAt.qƂB
	t.duplQ=T̎At.qƓyAɎcm[hP݂a.validP=TłB
	t.duplQ=F̎At.qƓyAɎm[h݂͑ȂB
	]āAt.duplQ=F̃m[ha.validP=T̃m[h̍v͒ǉyAƈv

q[vT؂ւ̃yA(x,y)̒ǉ
(1)ʏ̂QT؂ƓlɒǉByA(x,y)͒ǉm[ht.qɊi[BTL[q.xłB
	t.valibP=F(t.p=), t.duplQ=F
(2)ǉm[h獪ɌpXŁAq[v̈ʒu(m[h)TB
	ɐeA܂́A.e...
(3)a.płȂdispose(a)Ăa.pɂBa.q=a.p(a=t)Ȃt.duplQ=FƂB
	ła.pAa.validPsAt.duplQTƂB

m[h̐Ɩ؂ɒǉyA̐Ƃ͑SłB
m[hq.x͒T߂̂łnull͗L蓾ȂB
q[vFm[hƂ̎qm[hɑ΂ċɃyAƂ́At.p.yd.p.yłB
	l̏DƂq[vł́At.p.yd.p.yłB
tT؁Fm[h̍q؂̂ǂ̃m[hɑ΂Ăd.p.xt.q.xAd.q.xt.q.xłB
	lɁAEq؂̂ǂ̃m[hɑ΂Ăd.p.xt.q.xAd.q.xt.q.xłB
ۓFlyA鎞ɁAӂɑ召֌W`KvB
	ŁAɊi[yAz̓YpāAl{**kƌȂĔrB

ꊇ쐬iMcCreightŁj
	build(pair[])
	WŃ\[gBlist[]Ƀ\[gʂpair[]̓YXg
	root = build_sub(list, 0, nList - 1);
	oya(root)nil
	return root;

	build_sub(list, s, e);
	if( s > e )  nil ԂďIB
	i = ( s + e ) / 2; a = list[i];  //:pair[]YBpair[]͍q؂̂ő̃m[hƂȂ
	//ԃm[hpair[]
	r.q = a; r.p = 0;		//.A.͋
	r.left  = build_sub(list, s, i-1);
	r.right = build_sub(list, i+1, e);
	rc = node_add( r );
	if( ! isEmpty(r.left ) ) node.v[r.left ].oya = anode;
	if( ! isEmpty(r.right) ) node.v[r.right].oya = anode;
	//q[v.̋𖄂߂B
	extractP( anode );
	return anode;

--------------------------------------------------------------------------
TASYiMcCreightŁj

PSTreeQuery(T , [x1:x2]~[y0:])
́Fq[vTT ƂR[x1:x2]~[y0:]
óFR[x1:x2]~[y0:]ɗLT ׂ̂Ă̓_̃Xgans[]B
	//SplitNodeTB
	v  T.root
	vLast  null
	while v nullłȂ do
		vLast  v
		if v.validP then
			if v.p.yq[v𖞂 then
				v.p񍐂ׂǂׂ(xl̂ݒׂ)
				if v.q.x < x1 then
					v  v.right
				else if v.q.x > x2 then
					v  v.left
				else
					SplitNode𔭌̂Ń[vI
			else     //v.p.yq[v𖞂Ȃ
				v  null
		else //validPfalseȂ炻̉͌Ȃ
			v  null
	end while
	if vLast nullłȂ then
		vLast.p񍐂ׂǂׂ(x,ylɒׂ)
	vsplit  v
	if vsplitnull then Ȃ
	else
		// x1ւ̌oHɉCoH̐ߓ_Ƃ̉E̕؂̃f[^
		v  vsplit.left
		while v nullłȂ do
			v.q񍐂ׂǂׂ(v.q.x <= x2͏ɐ)
			if v.validP then
				if v.p.yq[v𖞂 then
					v.p񍐂ׂǂׂ(x1Ƃ̊֌Ŵݒׂ)
					if v.q.x >= x1 then
						ReportInPSTree(Tassoc(v.right), y0)
						v  v.left
					else
						v  v.right
				else    //v.p.yq[v𖞂Ȃ
					v  null
			else //validPfalseȂ炻̉͌Ȃ
				v  null
		end while
		// x2 ւ̌oHɉC̍̕؂̃f[^
		v  vsplit.right
		while v nullłȂ do
			v.q񍐂ׂǂׂ(v.q.x >= x1͏ɐ)
			if v.validP then
				if v.p.yq[v𖞂 then
					v.p񍐂ׂǂׂ(x2Ƃ̊֌Ŵݒׂ)
					if v.q.x <= x2 then
						ReportInPSTree(Tassoc(v.left), y0)
						v  v.right
					else
						v  v.left
				else     //v.p.yq[v𖞂Ȃ
					v  null
			else //validPfalseȂ炻̉͌Ȃ
				v  null
		end while

ReportInPSTree(anode, y0)
́Fq[vT؂̐ߓ_n Ǝ[y0:]
óFy[y0:]ɗLT ׂ̂Ă̓_B
	X^bNɃ{gnullvbV_EB
	v  anode
	while v nullłȂ do
		if ! v.duplQ then
			v.q񍐂ׂǂׂ(yl̂ݒׂ)
		if v.validP then
			if v.p.yq[v𖞂 then
				v.p񍐂ׂǂׂ(ׂ͕sv)
				if v.left nullłȂ
					if v.right nullłȂ
						v.rightvbV_EB
					v  v.left
				else if v.right nullłȂ
					v  v.right
				else
					v  |bvAbv
			else     //v.p.yq[v𖞂Ȃ
				v  |bvAbv
		else //validPfalseȂ炻̉͌Ȃ
			v  |bvAbv
	end while



========================================v[Xz_=================================================

m[hɂ͒ԃm[hleafm[ĥQނB̐͂Q~yA|PłB
	ԃm[hFEɎqm[hK݂B̐leafm[h|P(yA|P)łB
	leafm[hFEɎq݂ȂB̐̓yAƈvB
em[h́AyA(x,y)Ƃ(x,y)̂Q̃yABnull̂ƂB
	nullłleafm[h݂͑ȂBقƂǂleafm[ĥnullłB
	قƂǂ̒ԃm[ĥnullł͂ȂBinullł钆ԃm[h͗L蓾j
leafm[hplace holderƌĂԁB؂ɒǉyA̐leafm[h̐͑SłB
ԃm[hleafm[h|P݂Bԃm[hq.x͒T߂̂łnull͗L蓾ȂB
q[vT(place holder)̃m[hiԃm[h{leafm[hj͒ǉyAm~Q|PłB
yAq[vT؂ɂPǉƁAʏ͒ԃm[hleafm[ĥQ̃m[hǉB
	ȀԂōŏ̂Pڂ̃yA(x,y)ǉƂ́Aleafm[hPB
q[vFm[hƂ̎qm[hɑ΂ċɃyAƂ́At.p.yd.p.yłB
	l̏DƂq[vł́At.p.yd.p.yłB
tT؁Fԃm[hh̍q؂̂ǂ̃m[hɑ΂Ăd.p.xI.q.xAd.q.xI.q.xłB
	lɁAEq؂̂ǂ̃m[hɑ΂Ăd.p.xI.q.xAd.q.xI.q.xłB
ۓFlyA鎞ɁAӂɑ召֌W`KvB
	ŁAɊi[yAz̓YpāAl{**kƌȂĔrB
ԃm[hh̍̃m[hEm[hXƂǂ[leafm[hkƂƁB
	I.qL.qłB]āAh̍̃m[hleafm[hk̂ƂAI.qL.qłB
	tɁAleafm[hkeǂAŏɏo}̐em[hhƂƁA
	I.qL.qłB]āAq.xőłleafm[hɂ͓ԃm[h݂͑ȂB
ԃm[hhێyAAƂB
	L.qɕێleafm[hk獪ɎpXɂh݂͑B
	L.qɕێleafm[hk獪ɎpXɂh݂͑B

ꊇ쐬iv[Xz_Łj
pair[]̗L[x,y]PST蒼
PSTree::build()  //0: <0:G[ >0:f[^G[
	pair[]thisclear()B
		heapType,pair[],n_pair̓NAȂ
	Lpair[]̓YXg
	WŃ\[g
	root = PSTree::build_sub(Xg, 0, Xg.size()-1, &hight)
	oya(root)nil
PSTree::build_sub(list, s, e)  //0:list[s,e] >0:؂̍node[]Y <0:G[
	if s  e then 0 ԂďIB
	else if s  e then tm[hAԂďIB
		.list[]A.list[]A.hightP
	else
		i{j^QAlist[]  :pair[]YBpair[]͍q؂̂ő̃m[hƂȂ
		ԃm[hpair[]
			.A.͋
		.left build_sub(list, s  , i) ; oya(.left )
		.rightbuild_sub(list, i+1, e) ; oya(.right)
		.hight.left,rightvZ
		q[v.̋𖄂߂B
			PSTree::extractP(  )
	return r

̏pair[]ỸXgL1Bclear()͌Ăԑ
PSTree::getQList(sscvect *L1, int anode)
	if anodet then node[].qL1->push()
	else
		getQList(L1, node[].left)
		getQList(L1, node[].right)

Q̂ors(T1,T2)P̂orsBT1,T2ɋʂpair[]T3ɒǉ
PSTree::mearge(PSTree &T1, PSTree &T2, PSTree *T3)
	̏T1.pair[]ỸXgL1B
	̏T2.pair[]ỸXgL2B
	L1,L2pair}[WȂthis->pair[]ɒǉB
		́in,x,yjT3ɒǉBT3OȂCHKG[
	PSTreeꊇ쐬BPSTree::build()

--------------------------------------------------------------------------
TASYiv[Xz_Łj

PSTreeQuery(T , [x1:x2]~[y0:])
́Fq[vTT ƂR[x1:x2]~[y0:]
óFR[x1:x2]~[y0:]ɗLT ׂ̂Ă̓_̃Xgans[]B
	//SplitNodeTB
	v  T.root
	while v nullłȂ do
		if v.p > 0 then
			if v.p.yq[v𖞂 then
				v.p񍐂ׂǂׂ(xl̂ݒׂ)
				if v.q.x < x1 then
					v  v.right
				else if v.q.x > x2 then
					v  v.left
				else
					SplitNode𔭌̂Ń[vI
			else   //v.p.yq[v𖞂Ȃ
				v  null
		else //Ȃ炻̉͌Ȃ
			v  null
	end while
	vsplit  v
	if vsplitnull then Ȃ
	else
		// x1ւ̌oHɉCoH̐ߓ_Ƃ̉E̕؂̃f[^
		v  vsplit.left
		while v nullłȂ do
			if v.p > 0 then
				if v.p.yq[v𖞂 then
					v.p񍐂ׂǂׂ(x1l̂ݒׂ)
					if v.q.x >= x1 then
						ReportInPSTree(Tassoc(v.right), y0)
						v  v.left
					else
						v  v.right
				else     //v.p.yq[v𖞂Ȃ
					v  null
			else //Ȃ炻̐ߓ_͌Ȃ
				v  null
		end while
		// x2 ւ̌oHɉC̍̕؂̃f[^
		v  vsplit.right
		while v nullłȂ do
			if v.p > 0 then
				if v.p.yq[v𖞂 then
					v.p񍐂ׂǂׂ(x2l̂ݒׂ)
					if v.q.x <= x2 then
						ReportInPSTree(Tassoc(v.left), y0)
						v  v.right
					else
						v  v.left
				else     //v.p.yq[v𖞂Ȃ
					v  null
			else //Ȃ炻̐ߓ_͌Ȃ
				v  null
		end while

ReportInPSTree(anode, y0)
́Fq[vT؂̐ߓ_n Ǝ[y0:]
óFy[y0:]ɗLT ׂ̂Ă̓_B
	X^bNɃ{gnullvbV_EB
	v  anode
	while v nullłȂ do
		if v.p > 0 then
			if v.p.yq[v𖞂 then
				v.p񍐂ׂǂׂ(ׂ͕sv)
				if v.left nullłȂ
					if v.right nullłȂ
						v.rightvbV_EB
					v  v.left
				else if v.right nullłȂ
					v  v.right
				else
					v  |bvAbv
			else     //v.p.yq[v𖞂Ȃ
				v  |bvAbv
		else //Ȃ炻̐ߓ_͌Ȃ
			v  |bvAbv
	end while



http://web.cs.dal.ca/~nzeh/Teaching/Fall%202004/3110/Notes/augmented-ds-view.pdf(͖)

PST-insert(T, p)              //T:PSTree p:point
1 Insert p into T as into a standard binary search tree on the x-coordinates.
   Let l be the new leaf that stores p.
2 vl
3 while parent(v)nil and (parent(v) is empty or y(point(parent(v))) < y(p))
4    do vparent(v)
5 PST-Push(v, p)              //W̃q[vʒuTāÃm[hɂpush

PST-Push(v, p)                //v:node p:nil̎
1 while v is not empty
2    do qpoint(v)
3       point(v)p           //m[hɓ_B
4       pq                  //ɓĂ_͂̍/Epush
5       if x(p) < key(v)      //̃m[h܂ŌJԂB
6          then vleft(v)
7          else vright(v)
8 point(v)p

PST-Delete(T, x)
1 Find the node v that stores x and the leaf l corresponding to x.
2 Delete l as from a standard binary search tree.
3 if vl                     //v:폜Ώpoint x Ă钆ԃm[h
4    then PST-Pull(v)

PST-Pull(v)
1 while v is not empty        //ɂ͎̂ĂׂpointĂ
2    do wleft(v)
3       if point(w) == nil or y(point(right(v))) > y(point(w))
4          then wright(v)
5       point(v)point(w)    //ɓĂpoint͕svɂȂ
6       vw

PST-Rotate-Right(v)
1 wleft(v)
2 PST-Push(w, nil)
3 Binary-Tree-Rotate-Right(v) //]̍͂A͂̉EqpointnilɂȂA݂
4 PST-Pull(w)

=========================================McCreight=================================================
Priority Search Trees(internet sample)Bp.y̑傫q[vBq.xe.xEq.x̒T
                                   +-------+                  m[h
                                 |11(,21)|                     +---------+
                                   +-------+                   |TL[x|QT؂\
                                 |(33,33)|                     +---------+
                                   +-------+                   |yA(x,y)|q[v\
                                ^     |  _                     +---------+
                              ^      11    _
                    +-------+                 +-------+
                    | 3(,4) |                 | 14(,7)|
                    +-------+                 +-------+
                    | (2,12)|                 |(17,30)|
                    +-------+                 +-------+
                  ^    |  _                     |    _
                ^      3    _                  14      _
         +-------+         +-------+                    +-------+
         | 2(,12)|         | 4(,11)|            duplQ=T |17(,30)|
         +-------+         +-------+                    +-------+
         |       |         | (8,5) |            validP=T| (21,8)|
         +-------+         +-------+                    +-------+
             |                 |  _                    ^  |  _
             2                 4    _                ^   17    _
                                  +-------+    +-------+         +-------+
                                  | 8(,5) |    | 15(,2)|duplQ=F  | 21(,8)|
                                  +-------+    +-------+         +-------+
                                  | (5,3) |    |       |validP=F |       |
                                  +-------+    +-------+         +-------+
                                 ^   |            |                 |   _
                               ^     8           15                21     _
                          +-------+                                       +-------+
                          | 5(,3) |                                       |33(,33)|
                          +-------+                                       +-------+
                          |       |                                       |       |
                          +-------+                                       +-------+
                              |                                               |
                              5                                              33

yA̒ǉF(11,21) (14,7) (17,30) (21,8) (15,2) (33,33) (3,4) (2,12) (4,11) (8,5) (5,3)

=======================================v[Xz_=================================================
oTF	http://www.cs.brown.edu/courses/cs252/misc/resources/lectures/pdf/notes18.pdf
	uPriority Search Trees - Part IIv Prof. Roberto Tamassia Sem. II, 1993{1994
	Lecture 10 Date: May 22, 1994 Scribe: Michael Shapiro

Priority Search Trees(internet sample)Bp.y̑傫q[vBq.xe.xEq.x̒T
                                         +-------+                      ԃm[h
 }                                  |14(,7) |                         +---------+
(11, 21)                                 +-------+                       |TL[x|QT؂\
(14,  7)                                 |(33,33)|                         +---------+
(17, 30)                                 +-------+                       |yA(x,y)|q[v\
(21,  8)                             ^             _                     +---------+
(15,  2)                           ^                 _
(33, 33)                 +-------+                      +-------+       leafm[h
( 3,  4)                 | 4(,11)|                      |17(,30)|          +---------+
( 2, 12)                 +-------+                      +-------+        |   PH    | PH:place holder
( 4, 11)                 |(11,21)|                      |(17,30)|          +---------+
( 8,  5)                 +-------+                      +-------+         yA(x,y)
( 5,  3)               ^      _                        ^      _
                     ^          _                    ^          _
              +-------+          +-------+        +-------+        +-------+
              |   3   |          |   8   |        |   15  |        |   21  |
              +-------+          +-------+        +-------+        +-------+
              | (2,12)|          | (14,7)|        | (15,2)|        | (21,8)|
              +-------+          +-------+        +-------+        +-------+
              ^  _              ^  _             ^  _            ^  _
            ^      _          ^      _         ^      _        ^      _
        +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
        |   2   | |   4   | |   5   | |  11   | |   15  | |   17  | |   21  | |   33  |
        +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
        | (3,4) | | (4,11)| | (8,5) | |       | |       | |       | |       | |       |
        +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
         ^  _     (leaf)  ^  _         ^ _
       ^      _         ^      _     ^     _
+-------+ +-------+ +-------+ +-------+ +-------+ +-------+
|   2   | |   3   | |   5   | |   8   | |   11  | |   14  |
+-------+ +-------+ +-------+ +-------+ +-------+ +-------+
|       | |       | | (5,3) | |       | |       | |       |
+-------+ +-------+ +-------+ +-------+ +-------+ +-------+

jleafm[h(place holder)OČƃoXꍇB NT110330add
    leafm[h܂߂ČƃoXĂ͂B                           NT110330add

                                      +-------+                      ԃm[h
 }                               |   11  |                         +---------+
(11, 21)                              +-------+                       |TL[x|
( 3,  4)                              |(33,33)|                         +---------+
(14,  7)                              +-------+                       |yA(x,y)|
( 2, 12)                          ^             _                     +---------+
( 4, 11)                        ^                 _
(17, 30)              +-------+                      +-------+       leafm[h
( 8,  5)              |   4   |                      |   15  |          +---------+
( 5,  3)              +-------+                      +-------+        |   PH    | PH:place holder
(21,  8)              |(11,21)|                      |(17,30)|          +---------+
(15,  2)              +-------+                      +-------+         yA(x,y)
(33, 33)            ^      _                        ^      _
                  ^          _                    ^          _
           +-------+          +-------+          +-------+        +-------+
           |   3   |          |   8   |          |   14  |        |   17  |
           +-------+          +-------+          +-------+        +-------+
           | (2,12)|          | (8,5) |          | (14,7)|        | (21,8)|
           +-------+          +-------+          +-------+        +-------+
           ^  _              ^  _              ^  _             ^    _
         ^      _          ^      _          ^      _         ^        _
     +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
     |   2   | |   4   | |   5   | |   11  | |   14  | |   15  | |   17  | |   21  |
     +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
     | (3,4) | | (4,11)| | (5,3) | |       | |       | | (15,2)| |       | |       |
     +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+ +-------+
      ^  _    (leaf)     ^  _                                           ^  _
    ^      _           ^      _                                       ^      _
+-------+ +-------+ +-------+ +-------+                              +-------+ +-------+
|   2   | |   3   | |   5   | |   8   |                              |   21  | |   33  |
+-------+ +-------+ +-------+ +-------+                              +-------+ +-------+
|       | |       | |       | |       |                              |       | |       |
+-------+ +-------+ +-------+ +-------+                              +-------+ +-------+



yA̒ǉF(11,21) (14,7) (17,30) (21,8) (15,2) (33,33) (3,4) (2,12) (4,11) (8,5) (5,3)

*/

