/*
 * FILE     : recttree.cpp
 * Copyright (C) 2010 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : 敪(s){PSTree(p)ƂR̈(3R)B`dȂT
 * AUTHER   : N.Tsuchiya  2011.05.06
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include "recttree.h"

/*  ID_RectTree::getnum	low <= p <= high̃|CgԂ
***************************************************************************/
int RectTree::getnum( //o segt.ans[]
	int x1, int x2, int y1, int y2,
	time_t *tm3, int req[][4], int n_req)
{
	int rc, i, low[3], upp[3], n_ans = 0;
//	int lrOpen = 1;      //i JԎw 1: 2:E 3: J 0: NT120601
	int lrOpen = 2;      //i JԎw 1: 2:E 3: J 0:
if( tm3 != 0 ) {     //segt, drtʂɎԌv
	tm3[0] = clock();
	for( i = 0; i < n_req; ++i ) {
//		n_ans = this->segt.getAnsNum(lrOpen, req[i][0], req[i][1], req[i][2], req[i][3]);
		n_ans = this->segt.getAnsNum(lrOpen, req[i][1], req[i][2], req[i][3]);
	}
	tm3[1] = clock();
	for( i = 0; i < n_req; ++i ) {
		low[0] = req[i][0]; low[1] = INT_MIN; low[2] = req[i][2];
		upp[0] = req[i][1]; upp[1] = req[i][3];      upp[2] = INT_MAX;
		n_ans = drt.getnum(low, upp);
	}
	tm3[2] = clock();
}
	if( x1 > x2 || y1 > y2 ) { rc = 0; goto                 quit; }
	//敪؂T
	n_ans = this->segt.getAnsNum(lrOpen, x2, y1, y2);
	//̈؂TBx1<=X1<=x2 Y1<=y2 y1<=Y2
	low[0] = x1; low[1] = INT_MIN; low[2] = y1;
	upp[0] = x2; upp[1] = y2;      upp[2] = INT_MAX;
	n_ans = drt.getnum(low, upp);
	for( i = 0; i < n_ans; ++i ) {
		rc = this->drt.getinf(i);       //CHKA(0, rc, num);
//		if(dbgf[8]) { int ex = this->segt.ans.exist(rc); CHKB(0, ex, 0); }
//		this->segt.ans.push(rc);        //segt.ans̗p͂߂
		this->segt.ans.push_back(rc);   //segt.ans̗p͂߂
	}
	if(dbgf[8]) this->check_ans(x1, x2, y1, y2);  //query̓̃`FbN
//	this->drt.ans.clear();
//	for( i = this->segt.ans.first(); i >= 0; i = this->segt.ans.next(i) ) {
//	for( i = 0; i < this->segt.ans.size(); ++i ) {
//		this->drt.ans.push_back(i);
//	}
	rc = this->segt.ans.size();
quit:
	return rc;
}
/*  ID_RectTree::isCross	`̏dȂ蔻
***************************************************************************/
int RectTree::isCross(SegCoord &p, int X1, int X2, int Y1, int Y2 )
{
	return (p.x1 <= X2 && p.x2 >= X1 && p.y1 <= Y2 && p.y2 >= Y1);
}
/*  ID_RectTree::check_ans	query̓̃`FbN
***************************************************************************/
int RectTree::check_ans(
	int x1, int x2, int y1, int y2)
{
	int i, apoin, n_point = segt.points.a.size();

	segt.xlist.resize(n_point);
	for( apoin = 0; apoin < n_point; ++apoin ) segt.xlist[apoin] = 0;
	for( i = 0; i < segt.ans.size(); ++i ) {
		apoin = segt.ans[i];						CHKB(0, segt.xlist[apoin], 0);
		segt.xlist[apoin] = 1;
	}
	for( apoin = 0; apoin < n_point; ++apoin ) {
		SegPoint &p = segt.points.a[apoin];
		if( p.usef == 0 ) continue;
		i = isCross(p, x1, x2, y1, y2);
//		if( segt.ans.exist(apoin) ) {}
		if( segt.xlist[apoin] ) {
			CHKB(1, i, 1);
			if( i != 1 ) Dprintf("check_ans [%d] Q(%d,%d)(%d,%d) P(%d,%d)(%d,%d)\n", apoin, x1, y1, x2, y2, p.x1, p.y1, p.x2, p.y2);
		} else {
			CHKB(0, i, 0);
		//	Point &p = segt.points.a[apoin];
			if( i != 0 ) Dprintf("check_ans [%d] Q(%d,%d)(%d,%d) P(%d,%d)(%d,%d)\n", apoin, x1, y1, x2, y2, p.x1, p.y1, p.x2, p.y2);
		}
	}
	return 0;
}
/*  ID_RectTree::clear	g敪؂Ɨ̈؂čėp\ɂ
***************************************************************************/
int RectTree::clear()
{
	this->segt.clear();
	this->drt.clear();
	PSTree::nodes.clear();  //static oϐ
	PSTree::pairs.clear();  //static oϐ
	return 0;
}
/*  ID_RectTree::createTm	g敪؂Ɨ̈؂敪؂ꊇ\B
***************************************************************************/
int RectTree::createTm(
	 time_t *tm3)
{
	int rc;
	if( tm3 ) tm3[0] = clock(); 
	rc = this->segt.create();
	if( tm3 ) tm3[1] = clock(); 
	if( rc >= 0 ) rc = this->drt.create();
	if( tm3 ) tm3[2] = clock(); 
	return 0;
}
/*  ID_RectTree::create	g敪؂Ɨ̈؂敪؂ꊇ\B
***************************************************************************/
int RectTree::create()
{
	int rc = this->segt.create();
	if( rc >= 0 ) rc = this->drt.create();
	return 0;
}
/*  ID_RectTree::point_ins	create()pɒ`zɒPɓo^B
***************************************************************************/
int RectTree::point_ins(
	int poNo,   //i
	int xys[4]) //i x1, x2, y1, y2
{
	int rc, dim;                        CHKB(xys[0], xys[0], xys[1]);
	dim = 3;                            CHKB(xys[2], xys[2], xys[3]);
//	poi[0] = xys[0]; //x1;  NT120601
//	poi[1] = xys[2]; //y1;
//	poi[2] = xys[3]; //y2;
//	if( (rc = drt.point_ins(dim, poNo, poi)) < 0 ) goto                 quit; NT120601
	if( (rc = drt.point_ins(dim, poNo, xys + 1)) < 0 ) goto                 quit;
	if( xys[0] != xys[1] ) //x1 == x2 ͓o^Ȃ
		rc = segt.point_ins(poNo, xys);
quit:
	return rc;
}
/*  ID_RectTree::getinf	Ԗڂ̓_̔ԍԂ
***************************************************************************/
int RectTree::getinf(
	int k)         //̔ԍBO...create()̖߂l|P
{
	int rc;
	rc = this->segt.getAnsInf(k);
	return rc;
}
/*  ID_RectTree::addpoint	`ǉB
***************************************************************************/
int RectTree::addpoint(int ndNumber, int *pnt)
{
	int rc, dim;                        CHKB(pnt[0], pnt[0], pnt[1]);
	dim = 3;                            CHKB(pnt[2], pnt[2], pnt[3]);
//	poi[0] = pnt[0]; //x1;  NT120601
//	poi[1] = pnt[2]; //y1;
//	poi[2] = pnt[3]; //y2;
//	rc = drt.addpoint(dim, ndNumber, poi); NT120601
	rc = drt.addpoint(dim, ndNumber, pnt + 1);
	if( pnt[0] < pnt[1] )
		rc = segt.dst_ins(ndNumber, pnt);
	return rc;
}
/*  ID_RectTree::delpoint	̈؂瓮IɂP̓_폜
***************************************************************************/
int RectTree::delpoint(int ndNumber, int *pnt)  //0: <0:poNo[_o^Ȃ
{
	int rc;

	rc = drt.delpoint(ndNumber); //rc=0:, -1:m[hԍȂ
	if( pnt[0] < pnt[1] )
		rc = segt.dst_del(ndNumber, pnt); //0: <0:poNo[_o^Ȃ
	return rc;
}
/*  ID_RectTree::node0psts	m[hAyAOPSTree𐔂
***************************************************************************/
int RectTree::node0psts(int *drtNode0, int *segtNode0, int *drtPsts, int *segtPsts)
{
	int apsts;

	*drtNode0 = *segtNode0 = 0;
	*drtPsts = drt.psts.n_ary;
	for( apsts = 1; apsts < drt.psts.ary.size(); ++apsts ) {
		if( drt.psts.ary[apsts].emptyNext >= 0 ) continue;
		if( drt.psts.ary[apsts].n_node > 0 ) continue;
		*drtNode0 += 1;
	}
	*segtPsts = segt.psts.n_ary;
	for( apsts = 1; apsts < segt.psts.ary.size(); ++apsts ) {
		if( segt.psts.ary[apsts].emptyNext >= 0 ) continue;
		if( segt.psts.ary[apsts].n_node > 0 ) continue;
		*segtNode0 += 1;
	}
	return 0;
}

