/*
 * FILE     : segtree.h
 * Copyright (C)
 * SYSTEM   :
 * FUNCTION :
	[x,x]͓o^łȂ
 * AUTHER   :
 */
#if ! defined(SEGTREE_H)
#define SEGTREE_H

#include "ssc.h"
//#include "xset.h"
#include "segpst_memo.h"
#include "segtree_memo.h"

#if 0 //1:<vector>g 0:"sscvect.h"g
#   include <vector>
#   define VECTOR vector
    using namespace std;
#else
#   include "sscvect.h"
#   define VECTOR sscvect
#endif
#include "assoc_pstree.h"    // t\pB

typedef int RbtData;
enum RbtColor { RED, BLACK };

struct SegCoord {
	int 	x1,x2,y1,y2;      // `
	SegCoord() : x1(0),y1(0),x2(0),y2(0){}
	SegCoord(int X1,int X2,int Y1,int Y2) : x1(X1),y1(Y1),x2(X2),y2(Y2){}
	static int isCross(int lrOpen,SegCoord &p, int *xyy);
};
struct SegPoint : public SegCoord { //̃|Cg
//	int 	x1,y1,x2,y2;      // `
	int		usef;             // 0:, 1:gp
	SegPoint() : usef(0){}
	SegPoint(int X1,int X2,int Y1,int Y2,int uf) : SegCoord(X1, X2, Y1, Y2), usef(uf){}
} ;
struct SegPoints {            //̃|Cg̏W
	int num;                  //󂫂܂߂ă|Cg
	VECTOR<SegPoint> a;       //̃|Cg̔zB[0]g
	SegPoints() : num(0) {}   //RXgN^
	~SegPoints(){}                                //fXgN^
	int clear();
	friend struct SegTree;
private:
	int ins(int no, int *x);
	int del(int idx);
	int find(int no, int *x) {
		if( no < 0 || no >= a.size() ) no = -1;
		else if( a[no].usef != 1 ) no = -1;
		return no;}
} ;
struct SegNode {              //敪؂̐ߓ_Bnode[0]͎gȂ
	//double key;
	int key  ;                //El
	int left ;                //-1:                                           node[]or-1
	int right;                //͎̎̋B擪SegNodes::topEmpty        node[]
	int oya  ;                //ԍؗpB폜
	int minv ;
	int maxv ;
	int usecnt;               //L[lI[ɎBOɂȂ폜Bԃm[ĥ
	int asocT;                //t؁BPSTreeB0:tؖ W     psts.ary[]or0
	int topPair;              //create̎ɓo^W̐擪BNT120608
	RbtColor color; // F
	char segt_act;            //ANeButOB 1:܂͎qsegt_pstɋłȂm[h
	SegNode() : key(0), left(0), right(0), oya(0), minv(0), maxv(0), usecnt(0), asocT(0), topPair(0), segt_act(0), color(BLACK) {}
	SegNode(int pkey,int ucnt,int pmin,int pmax) : key(pkey), left(0), right(0), oya(0), minv(pmin), maxv(pmax), usecnt(ucnt), asocT(0), topPair(0), segt_act(0), color(BLACK) {}
	~SegNode(){} //fXgN^Ăяo
	SegNode(const SegNode& X){
		memcpy(this, &X, sizeof(SegNode));}
	SegNode& operator=(const SegNode& X) { if( this != &X ) { 
		memcpy(this, &X, sizeof(SegNode));} return(*this);}
} ;
struct SegNodes {             //敪؂̐ߓ_̏W
	int num;                  //󂫂ߓ_
	int topEmpty;             // node[]
	VECTOR<SegNode> a;        //敪؂̐ߓ_̔zBa[0]͎gȂ
	SegNodes() : num(0), topEmpty(0){ a.push_back(SegNode()); }   //RXgN^
	~SegNodes(){}             //fXgN^
	int clear();
	int ins(int poya, int xkey, int ucnt, int min, int max);
	int del(int idx);
	SegNode& get(int idx);
} ;
int rb_comp(int,int);
struct SegTree {              //敪
	PSTrees psts;             //NT120405
//r	int mainTree;             //ŏʖ؂̍m[h                 node[]
	int root;                 //ŏʖ؂̍m[h                 node[]
	int (*compare)(int,int);  // r֐ <0: >0:E 0:
	const int nil;            //=0 NILߓ_ (ԕ)
	SegNodes  nodes;
	SegPoints points;
//	Xset_s ans;               //point[] i[
	VECTOR<int> ans;          //point[] i[
	VECTOR<int> xlist;        //SegTree::create()Ŏgp //NT120529
	VECTOR<int> xsortwk;       //SegTree::create()Ŏgp subQuery()side3Query()p
	VECTOR<int> usecnt;       //SegTree::create()Ŏgp subQuery()side3Query()p
	VECTOR<int> ulist;        //SegTree::create()Ŏgp //NT120529

	SegTree();                //RXgN^
	~SegTree(){}              //fXgN^
	//g敪؂čėp\ɂ
	int clear();
	//`(x1,x2,y1,y2)𓮓Iɓo^B
	int dst_ins(int poNo,int *xi);
	//`(x1,x2,y1,y2)폜B
	int dst_del(int poNo, int *xi);
	//`(x1,x2,y1,y2)o^Ă邩`FbNB
	int dst_check(int poNo, int *xi);

	//P̓__WɒǉBcreate()ĂŊg敪؂ꊇ\
	int point_ins(int poNo,int *xi); //dimׂ͂ēƁBpoNôQd`͕sB
	//g敪؂ꊇ\Bpoint_ins()Œ`o^ɁB
	int create();
	//low <= p <= high̓_̐Ԃ
	int getAnsNum(int lrOpen, int x0, int y1, int y2);
	//Ԗڂ̓̓_̔ԍԂ
	int getAnsInf(int k);
	int getNodeNum(int *pstNodeNum, int *pstPairNum); //nodes.numԂBPSTm[hݒ

	int countActive(int anode, int *active, int *nnode);
//	int check_ans(int lrOpen,int x1, int x2, int y1, int y2);
	int check_ans(int lrOpen, int *xyy);
	int tree_check1(int anod, int oynod, int xrangeL, int xrangeR );
	void dump_nod(PSTrees &psts);
private:
	//int BuildSegTree(int num,int *Plist,int *hi,int rootf);
	int BuildSegTree(int num,int *Plist,int *usecnt,int poya,int rootf, int xrangeL, int xrangeR, int bh);
//	int subQuery(int anode, int lrOpen, int *xyy, Xset_s &ans0);
	int subQuery(int anode, int lrOpen, int *xyy, VECTOR<int> &ans0);
	int segt_insdel(int anode,int apoint, int low, int high, int insdel, int *actFlag );
	int segt_insert(int anode,int apoint, int low, int high,int insdel, int *actFlag );
	int segt_delete(int anode,int apoint, int low, int high, int *actFlag );
//	int stabbingQuery(int anode,int lrOpen,int *xyy, int xx, Xset_s &ans);
	int stabbingQuery(int anode,int lrOpen,int *xyy, int xx, VECTOR<int> &ans);
	int genPst(int anode,VECTOR<int> &sortwk);

	//RbTree::public
	int add(        //R 0: -2: -4:̈mۂɎs -5:r֐o^ <0:G[
		int val);   //i L[ƂȂlBz̓YȂǁB
	// ؂m[hP폜B
	int del(        //R 0: -1:݂Ȃ -5:r֐o^  <0:G[
		int val);   //i L[ƂȂlBz̓YȂǁB
	// ؂Ãm[ḧʒuɕۑB
	int find(       //R >=0:݂ -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //o
		int val);	//i L[ƂȂlBz̓YȂǁB
	// ؂̍ŏ^ő̃m[h̒lԂÃm[ḧʒuɕۑB
	int first(      //R >=0:擾vall -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //o
		int mode);  //i o̒`(1:ŏ̃m[h珬 -1:ő̃m[h傫)
	// ؂玟̒lԂB̒ĺ|PԂB
	int next(       //R >=0:擾vall -1:݂Ȃ -5:r֐o^  <0:G[
		int *inf ,  //io
		int mode);  //i o̒`(1:ɑ傫m[h -1:ɏm[h)
	// ؂̃`FbNBoXA召֌WAm[h
	int	check(){int chk_sav = chk_; rb_check(root); return chk_ - chk_sav;}
	// ؂̃_v
	//RbTree::private
	int rbtree_minimum(int x);
	int rbtree_successor(int x);
	int rb_search(RbtData k);
	int check_rotate_fixup(int x,int y);
	int rb_rotate_fixup(int a, int x, int b, int y, int c);
	void left_rotate(int x);
	void right_rotate(int x);
	void rb_insert_fixup(int x);
	int  rb_insert(RbtData k, int *fndfg);
	void rb_delete_fixup(int x);
	int case3_degree2(int z,int y);
	int rb_delete(RbtData k);
	int allocate_node(int oya,int ko,RbtData k,int ucnt);
	void free_node(int x);
	void print_tree(int x, int lv); //gp
	int rb_check(int x);
	int SegTree::compInt(const int *p, const int *q);
} ;
#endif //! defined(SEGTREE_H)
