/*
 * SYSTEM	: nVXeWCu
 * FILE 	: segtree_memo.h
 * All Rights Reserved, Copyright(C) 2011, Sogen System Co., Ltd.
 * FUNCTION : I敪 Dynamic Segment Trees
 * AUTHER	: N.Tsuchiya  2011.05.18
 */
/*
敪 Segment Trees    2011/05/17`   y

yLecture05_handout.pdfz
Lecture 5, CS 631100 Segment Trees & Interval Trees
http://3glab.cs.nthu.edu.tw/~spoon/courses/CS631100/Lecture05_handout.pdf
yI敪؁zDynamic Segment Trees for Ranges and Prefixes
Yeim-Kuan Chang and Yung-Chieh Lin, IEEE Trans. on computers, Vol56, No 6, June 2007

==========================================================================
敪 Segment Trees
==========================================================================
Tv
	̒[_ƁA[-,][_ŕԂtƂ镽t񕪒T؁B
	[_tƂĎȂlB
	ǂ̐ߓ_IuAE̎qv,ŵƂAhuhvhwłB
	ߓ_̋Ԃ[-,]łAƂ̗t̋Ԃ̊Jn_-łB
	[a,b]͐ߓ_̋Iv܂݁A̐eߓ_̋Iu܂܂ȂƂɐߓ_i[B
	P̐͋IuɊ܂܂t獪ɂpXɂ傤ǂP̐ߓ_ɌB
	͓x̍XQ̐ߓ_ɂi[ȂB

--------------------------------------------------------------------------
@\
1D敪؁Fh(stabbing)B
	P̐ri[xi,yi]̏Wr~āA_ɑ΂āAxiyi𖞂ri߂B
ÓI敪؂ł͐VȒ[_̒ǉAsvɂȂ[_̍폜͂łȂB

2D敪؁FQԏ̒`i[Ď_Ɋ܂ޒ`̏W߂

--------------------------------------------------------------------------
\
                                   \z            T             (ǉ)          (폜)
1D敪              mlogm          mlogm        logm{j            logm           logm    
2D敪            m(logm)**2     m(logm)**2     (logm)**2{j      (logm)**2      (logm)**2
d敪         m(logm)**d     m(logm)**d     (logm)**d{j      (logm)**d      (logm)**d
͐A͒oB
ǂ폜ɂ͐ߓ_ɂXg폜ΏۂT߂̍HvKvB

--------------------------------------------------------------------------
y\L@znotation
Qԏ̐W S = (s1, s2, . . . sn) ƂB
r̐̒[_̂wW̏W d B
ʂ̒[_͖̂Ɖ肷BȂ킿A|d| = 2n
d̒[_͏Ƀ\[gĂBd = {1 < 2 < . . . 2n}
ynԁzAtomic intervals
d= {1 < 2 < . . . 2n} ͂w 2n + 1 ̌nԂɕB
	[0, 1] i0-j
	[i, i+1] for i  {1, 2, . . . 2n-1}
	[2n,2n+1] i2n+1j
2n + 1 ̌nԂ͋敪؂s̗tߓ_ƂȂB
̃^Cv̋敪؂ł͕O͈̐Ȃ(y)B

inԂ(-,e1)[e1,e1](e1,e2)[e2,e2],   ,(e2n-1,e2n)[e2n,e2n](e2n,)ƂS{Pɂ镶
O̐ɂ[ei,ei]Ԃ̗tߓ_KvƂȂB
܂AɂċԂJA݂̂̂ƂɂKvƂȂB
̃^Cv̋敪؂ł͓ߓ_() (] [) []̂S̋ԂʂĕێKvB

yߓ_zinternal nodes
敪؂s͕tQ؂łB
ߓ_͕KE̎qߓ_B
ߓ_̂Q̎qCƂƁAhuhvhwƂȂ{elementary hntervalB
hvhw͘AĂA̗[̓_͂d̗vfłBԂ̋E̒luƂB


ytߓ_z
nԂƂP΂PɑΉߓ_ōqEqB

yƐߓ_z
e[a,b]͐ߓ_̋[ei, ej]܂݁AA̐eߓ_̋Ԃ܂܂ȂƂ
ߓ_Ɋi[BȂ킿Aߓ_̊{Ԃ[a,b]Ɋ܂܂Ƃɋ߂ߓ_Ɋi[B
Ɋ܂܂ǂ̗tߓ_ɑ΂ĂA獪ɎpXɂi[ߓ_KP݂B
͓x̍XQ̐ߓ_ɂi[ȂiƗlXȎɂ邪Auxv̒`j
tߓ_[c,d]Ɋi[ꂽ[a,b]͈܂͗̒[_tߓ_̋Ԃ̋ElɈvB
eߓ_̍q̏ꍇdb͈vBȂȂAdbƂƂ͂̉Eqߓ_̋Ԃ܂ł܂B

ytWzStandard lists
ߓ_ɓo^̃XgkutWƌĂԁB
kuɓo^̂́Ahu  [ei,ej]  hparent(u)  [ei,ej]łȂɌB
Ȃ킿A͖؂s̍ɍł߂A{ԂɊ܂܂ߓ_ɓo^B
tWAVL؁Aԍ؂Ȃǂō\邪A`dȂł̓q[vT(priority search tree)pB


yhzPseudo-code for answering a stabbing query
_xl܂ނ̐n({log)̎Ԃŗ񋓂B
Algorithm StabbingQuery(u, xl)
	: s̍ߓ_ƁÂwWxlB
	o: ƌ̏WkiĂԑŏĂj
	1. if u == NULL
	2.     then return
	3. ߓ_ɓo^ĂXgkuSĂkɒǉB
                 iQxkɒǉSz͖jj
	4. if xlIu.leftixluAuIu.leftIu.right̋Elj
	5.     then StabbingQuery(u.left, xl)
	6. if xlIu.rightixluj
	7.     then StabbingQuery(u.right, xl)
5.7.ׂ̗̂́Axlߓ_̍E̋Ԃ̋EuƓB
xlȕꍇA
	̍[_肩珜Oꍇi̍[Jj́AE}𒲂ׂȂB
	E[_Oꍇ́A}𒲂ׂȂB

y敪؂̍쐬zConstructing a segment tree T
Algorithm ConstructSegmentTree
	: Qʏ̐Wr
	o: 敪؂s
	1. Wr猴nԂ̏W߂B
	2. nԂtߓ_ƂBBST(Balanced Binary Search TreetQT)sB
	3. PsɒǉĂByǉz

yǉzPseudo-code for inserting a segment s
敪؂ɂn(log)̎ԂŒǉB
OF̍E̒[_͋敪؂ɒǉς݂ł邱ƁB
Algorithm InsertSegment(u, s)
: s̍ߓ_ƁA[_x-  x+łB
1. if hu [x-, x+]
2.     then XgkuɒǉB
3. else
4.     if [x-, x+]  hu.left  O iP_݂̂̏dȂȂthenɍsȂByj
5.         then InsertSegment(u.left, s)
6.     if [x-, x+]  Iu.right  O
7.         then InsertSegment(u.right, s)

yzA property on segment trees
Property
    s is stored at most twice at each level of T .
Proof.
	Wefll prove by contradiction.
	Suppose contrary: s stored at more than 2 nodes at level i.
	Let u be the leftmost such node, u0 be the rightmost.
	Let v be another node at level i containing s.
	Then Iv.parent  [x-, x+], which is a contradiction.
	Hence s cannot be stored at v.
yAnalysisz
Property of previous slide implies
    Space complexity: O(n log n)
Insertion in O(log n) time
    (Due to previous slide: at most four nodes are visited ateach level)
Query time: O(k + log n)
Preprocessing time:
    Sort endpoints: O(n log n) time
    Build empty segment tree T over endpoints: O(n) time
    Insert n segments into T : O(n log n) time
    Overall: O(n log n) preprocessing time


yI敪؁zDynamic Segment Trees for Ranges and Prefixes
Yeim-Kuan Chang and Yung-Chieh Lin, IEEE Trans. on computers, Vol56, No 6, June 2007

yI敪؂̉]z
]O̖؂̍\͎̂悤ɂȂĂB}QƁB
y.right = c
y,left  = b
x.right = y
x.left  = a
x,y,a,b,c͐ߓ_\B

}͏オEAAƂČBɂXOxȂČƒxǂB
]
           +-(b)               +-(b')        b{x
       +-(x)        k]   (x')            w
       |   +-(a)    =====>     |   +-(a')    (a|w'){x
     (])            <=====     +-(]')        `a
       +-(`)        q]         +-(`')    `|w'

(])͐ߓ_̕tW\B
eߓ_͋rangeeƂ̎qa,y̋Ԃ̊֌ẂA
x.range = y.range + a.rangełB
(x)̐y.range܂ł邪̐ex.range͊܂łȂB
Q̌Zߓ_y,a̕tW̋ʕ͋łB`xOAabOB
eq̐ߓ_ɂĂlłBaxOAbxOB
k]ɂVȊeߓ_̐W͈ȉ̂悤ɌvZB
x'w
]'`a
`'`|w'`|`a
b'b{x            bƂxɋʂ݂̐͑Ȃ
a'(a|w'){x     aƂxɋʂ݂̐͑Ȃ

L͎̂悤ɉ߂łB
eقȂĂ`Ca͌ZɂȂ̂ŗ̕tW̋ʂ̐ewɈڂB
ZłaCb͐eقȂ̂ŐexɂaƂbɈڂB

y[_̒ǉz
ʏ̂QTő}ꏊTB̏ꏊ̐eߓ_Aq̗tߓ_ƂB
؂̏ꍇ͂nilłBtߓ_͖؂ł݂B
tߓ_̋Ԃ[a,b]Ƃ

𒆊Ԑߓ_ɕύXBȂ킿A  ---------------vO͈Ă̂łꂠ킹B
.key[_̍Wl
Q̗tߓ_AA̍E̎qɂB
A̎Ԃ͂̋Ԃ.keyŕ̂ŁAꂼ[a,.key]A[.key,b]łB
̕tW͕ςȂBA̕tW͋łB
̐FԂɂ
ԍ؂𒲐B

y[_̍폜z
폜ɁA̐̒[_ɑΉߓ_폜B
̐̒[_łꍇɂ͂܂폜łȂB
폜[_ɑΉߓ_ƂB

iꍇPFj̍Eqt̏ꍇ
tߓ_ɕύX邾BȂ킿A  ---------------vO͈Ă̂łꂠ킹B
.keyO
..EnilAE̗tߓ_͎̂ĂB
̋ԂƕtW͕ςȂB
̏ꍇ́Aԍ؂𒲐B

̎qߓ_̕tW̐́A̋Ԃ܂܂Ȃ͂A.key[_ƂĎB]āA
.key[_Ƃ͍폜ς݂Ȃ̂ŁA̍Eq̕tW͋łB

iꍇQFj̈̎qtߓ_łԐߓ_̏ꍇ
ԍ؂̏ꍇł͗t獪ɎpX̍̐ߓ_͑SēA͐Ԃł͍łB
ɁA̎q͗tߓ_łBitߓ_͏ɍBj
`uk؂̏ꍇ͂ǂ̐ߓ_̍Eq؂̍̍́}POA͂A̎q͗tߓ_łB
.key[_Ƃ͍폜ς݂Ȃ̂ŁA̍EqA̕tW͋łB<== E\H
ߓ_̋Ԃ[a,b]ƂB

.tW.tW
̉Eq̏ꍇ́A̍q̋Ԃ̍E.keyaɕύXB
̍q̏ꍇ́ẢEq̋Ԃ̉EE.keybɕύXB
Ƃ̐eƂ̐ڑAƂ̐eƂ̐ڑɐ؂ւ
Ƃ͎̂ĂB
̐FԂ獕ɕύXB
ԍ؂͕̒svB

yz
orsɂȂv[ɕԂAKvɂȂmۂ邱ƂŃߖ

*/
